/*
 *
 * File: IEDataMetaDragAndDrop.java
 * Date: Oct 29, 2009; 5:22:36 PM
 */
package de.desy.mst.libs.accelerator;

/**
 * This is the interface which is used for Java's Drag & Drop facilities and
 * performs an ordinary method which returns a string value which can be 
 * copied between different components. It can be used with Java's 
 * {@code DataTransport} class from the AWT framework for the Drag & Drop 
 * facilities.  
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataMetaDragAndDrop.java 30052 2009-11-08 16:09:03Z walla $
 */
public interface IEDataMetaDragAndDrop
{
	/**
	 * Returns the string value of the data element as a transferable 
	 * information on the Drag & Drop facility of Java. Currently this can be a 
	 * special TINE address which is transformed to the string value and used 
	 * as a Java Drag And Drop facilities. But it can also include any other 
	 * value one wants to Drag & Drop to any remote or local Swing component.
	 * 
	 * @return Returns the transformed string value.
	 */
	public abstract String getTransferableData();
}
/* end of file */