/*
 *
 * File: IEDataSendNumber.java
 * Date: Feb 1, 2008; 4:53:29 PM
 */
package de.desy.mst.libs.accelerator;

/**
 * <p>This is a data component interface which holds constant values which are
 * send to the hardware before sending the special objects via the listener
 * method.</p>
 * <p>For example DESY 2 needs such an interface to switch between different
 * cavity in their mode.</p>
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataSendNumber.java 19223 2008-11-28 11:44:19Z walla $
 */
public interface IEDataSendNumber
{
	/**
	 * Sends constant number or numbers to the hardware before sending the
	 * special value via a TINE link.
	 *
	 * @return Returns the special sending parameters as its significant values.
	 */
	public abstract short[] sendNumber();
}
/* end of file */