/*
 *
 * File: HardwareException.java
 * Date: Nov 23, 2006; 5:02:11 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * This exception is thrown when the hardware doesn't respond or returns
 * error values.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: HardwareException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class HardwareException extends Exception
{
	/** Is the serial version UID to unify this class. */
	static final long serialVersionUID = 125060539210010953l;
	
	/**
	 * The constructor of this exception.	 
	 */
	public HardwareException()
	{
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 */
	public HardwareException(String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
     *
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public HardwareException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public HardwareException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */