/*
 *
 * File: InvalidKeyException.java
 * Date: Aug 14, 2007; 5:19:27 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * This exceptions is thrown if you wanted to access a key on an associated map 
 * which does not exist or already is in the map.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: InvalidKeyException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class InvalidKeyException extends RuntimeException
{
	/** Is the serial version UID to unify this class. */
	public static final long serialVersionUID = 6320038958585810224l;

	/**
	 * The key element of an associated map is invalid.
	 */
	public InvalidKeyException()
	{
	}

	/**
	 * The key element of an associated map is invalid.
	 * 
	 * @param message_ Is the message.
	 */
	public InvalidKeyException(String message_)
	{
		super(message_);
	}

	/**
	 * The key element of an associated map is invalid.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public InvalidKeyException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The key element of an associated map is invalid.
	 * 
	 * @param message_ Is the message.
	 * @param cause_ Is the throw able cause of this exception.
	 */
	public InvalidKeyException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */