/*
 *
 * File: ObserverableException.java
 * Date: Oct 19, 2006; 9:29:56 AM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * This exception is thrown if a class needs an observerable (which is the same
 * as a Subject) of the Oberservable design pattern <b>before</b> any other method is
 * called. This is normaly set by a method or class method called 
 * {@code setSubject(IDeviceSubject)}.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: ObserverableException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class ObserverableException extends IllegalArgumentException
{
	/** Is the serial version UID to unify this class. */
	public static final long serialVersionUID = -484541200344523693l;
	
	/**
	 * Creates this exception.
	 */
	public ObserverableException()
	{
		super();
	}

	/**
	 * Creates this exception.
	 *
	 * @param message_ Is the message to hold in this exception.
	 */
	public ObserverableException(String message_)
	{
		super(message_);
	}

	/**
	 * Creates this exception.
	 * 
	 * @param cause_ Is a throwable.
	 */
	public ObserverableException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * Creates this exception.
	 * 
	 * @param message_ Is the message to hold in this exception.
	 * @param cause_ Is a throwable.
	 */
	public ObserverableException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}
}
/* end of file */