/*
 *
 * File: TineUnknownDataTypeException.java
 * Date: Jun 12, 2008; 9:54:12 AM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * This TINE exception is thrown if one wants to declare a TINE data type
 * which doesn't exist. It is only responsible for the beginning of a project
 * and not all primitive TINE data types are declared. 
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: TineUnknownDataTypeException.java 12621 2008-06-12 08:18:31Z walla $ 
 */
public class TineUnknownDataTypeException extends RuntimeException
{

	/** Is the serial version UID to unify this class. */
	public static final long serialVersionUID = 2455204066034123485l;

	/**
	 * The constructor of this exception.
	 */
	public TineUnknownDataTypeException()
	{
		super();
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 */
	public TineUnknownDataTypeException(final String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public TineUnknownDataTypeException(final Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public TineUnknownDataTypeException(final String message_,
			final Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */