/*
 *
 * File: UnknownObserverObjectException.java
 * Date: Nov 17, 2006; 9:46:13 AM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * If the overgiven object via the {@code IDeviceSubject.notfyObservers(Object)} is 
 * invalid or does not exist this exception is thrown.
 * 
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: UnknownObserverObjectException.java 12066 2008-05-29 08:35:57Z walla $
 * @see de.desy.mst.libs.accelerator.IDeviceSubject#notifyObservers(Object)
 */
public class UnknownObserverObjectException extends ObserverableException
{
	/** Is the serial version UID to unify this class. */
	final static long serialVersionUID = 5211069582935203443l;

	/**
	 * Creates this exception.
	 */
	public UnknownObserverObjectException()
	{
		super();
	}

	/**
	 * Creates this exception.
	 * 
	 * @param message_ Is the message to hold in this exception.
	 */
	public UnknownObserverObjectException(String message_)
	{
		super(message_);
	}

	/**
	 * Creates this exception.
	 * 
	 * @param cause_ Is a throwable.
	 */
	public UnknownObserverObjectException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * Creates this exception.
	 * 
	 * @param message_ Is the message to hold in this exception.
	 * @param cause_ Is a throwable.
	 */
	public UnknownObserverObjectException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */