/*
 *
 * File: IMonitorStruct.java
 * Date: Mar 2, 2009; 5:45:49 PM
 */
package de.desy.mst.libs.accelerator.model;

import de.desy.tine.structUtils.TTaggedStructure;

/**
 * <p>This is the java interface of monitoring all hardware values which are
 * delivered by a TINE tagged structure type, which all are inherited from the 
 * interface {@code TTaggedStructure}. These values are delivered by the method of 
 * {@link #getDataStructures()}. Remember that this is a <b>SINGLE TLink</b>
 * call!</p> 
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IMonitorStruct.java 22532 2009-03-06 16:16:36Z walla $
 */
public interface IMonitorStruct<T extends TTaggedStructure> extends IMonitor
{
	/**
	 * <p>Returns the TINE tagged structure elements of the initialized device 
	 * group directly from the TINE protocol.</p>
	 * 
	 * @return Returns a list of the current device name. This is a type which
	 * 		extends the class of {@code TTaggedStructure}.
	 */
	public abstract T[] getDataStructures();
}
/* end of file */