/*
 *
 * File: APolygonButton.java
 * Date: Nov 3, 2006; 2:27:08 PM
 */
package de.desy.mst.libs.accelerator.view;

import java.awt.Component;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Polygon;

import javax.swing.AbstractButton;
import javax.swing.JToolTip;

/**
 * This abstract class will display a polygon on the screen which can be selected.
 * Its feature is when you go inside the polygon its drawn with active color pair\
 * and when your are outside of it, it is drawn in inactive color pair. For more
 * information on the concrete realization of this button you should follow the
 * links above.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: APolygonButton.java 32894 2010-02-08 12:53:07Z walla $
 */
@Deprecated
public abstract class APolygonButton extends AbstractButton
{
	/** This is the current unique serial version UID. It helps the application
	 * to control serialization compatibility between versions. */
	private static final long serialVersionUID = -8593511220760852459L;

	/** Is the active color if the mouse is inside the button. */
    protected Color _colorActive = null;

	/** Is the active border color if the mouse is inside the button. */
    protected Color _colorActiveBorder = null;

	/** Is the inactive color if the mouse is outside the button. */
    protected Color _colorInactive = null;

	/** Is the inactive border color if the mouse is outside the button. */
    protected Color _colorInactiveBorder = null;

	/** Is the current tool tip as an instance of {@code JToolTip}. */
	protected static JToolTip _toolTip;

	/** Is the parent component. */
    protected Component _parent = null;

	/** Is the polygon to be drawn in the graphical zone. */
    protected Polygon _polygon = null;

	/** Is the boolean value which says if the button is actibe ({@code true})
	 * or not ({@code false}).*/
    protected boolean _isActive = false;

    /**
     * Will set the activity of the button. It is a boolean value.
     *
     * @param isActive_ A boolean value which shows the activity of the button.
     * 		It is set to {@code true} if it is active otherwise it is {@code false}.
     */
    @Deprecated
    public abstract void setState(boolean isActive_);

    /**
     * This is the constructor of the abstract polygon button. It will set the
     * parent which can not be null.
     *
     * @param parent_ The parent element who has called this constructor.
     */
    @Deprecated
    protected APolygonButton(Component parent_)
    {
    	super();

        if (parent_ == null)
            throw new IllegalArgumentException("The parent component cannot be" +
            		" null!");

        _parent = parent_;
        _polygon = null;

        _isActive = false;

        _colorActive = ViewConstant.COL_ACTIVE;
        _colorActiveBorder = ViewConstant.COL_ACTIVE_BORDER;
        _colorInactive = ViewConstant.COL_INACTIVE;
        _colorInactiveBorder = ViewConstant.COL_INACTIVE_BORDER;


        setOpaque(false);
    }

    /**
     * This is the constructor of the abstract polygon button. It will set the
     * parent which can not be null. The other parameter can be null.
     *
     * @param parent_ The parent element who has called this constructor.
     * @param polygon_ Is the polygon to be drawn in the graphical zone.
     */
    @Deprecated
    protected APolygonButton(Component parent_, Polygon polygon_)
    {
    	this(parent_);

        if (polygon_ == null)
            throw new IllegalArgumentException("The polygon cannot be null!");

        _polygon = polygon_;
    }

    /**
     * This is the constructor of the abstract polygon button. It will set the
     * parent which can not be null. All other parameters can also be null.
     * Most of them will be set to default values.
     *
     * @param parent_ The parent element who has called this constructor.
     * @param colorActive_ Is the active color when the mouse is inside the
     * 		button.
     * @param colorInactive_ Is the inactive color when the mouse is outside
     * 		the button.
     */
    @Deprecated
    protected APolygonButton(Component parent_
    		, Color colorActive_, Color colorInactive_)
    {
    	this(parent_);

    	_colorActive = (colorActive_ == null) ? ViewConstant.COL_ACTIVE : colorActive_;
        _colorActiveBorder = ViewConstant.COL_ACTIVE_BORDER;
        _colorInactive = (colorInactive_ == null) ? ViewConstant.COL_INACTIVE : colorInactive_;
        _colorInactiveBorder = ViewConstant.COL_INACTIVE_BORDER;
    }

    /**
     * This is the constructor of the abstract polygon button. It will set the
     * parent which can not be null. All other parameters can also be null.
     * Most of them will be set to default values.
     *
     * @param parent_ The parent element who has called this constructor.
     * @param polygon_ Is the polygon path of this class.
     * @param colorActive_ Is the active color when the mouse is inside the
     * 		button.
     * @param colorInactive_ Is the inactive color when the mouse is outside
     * 		the button.
     */
    @Deprecated
    protected APolygonButton(Component parent_, Polygon polygon_
    		, Color colorActive_, Color colorInactive_)
    {
    	this(parent_, polygon_);

    	_colorActive = (colorActive_ == null) ? ViewConstant.COL_ACTIVE : colorActive_;
        _colorActiveBorder = ViewConstant.COL_ACTIVE_BORDER;
        _colorInactive = (colorInactive_ == null) ? ViewConstant.COL_INACTIVE : colorInactive_;
        _colorInactiveBorder = ViewConstant.COL_INACTIVE_BORDER;
    }

    /**
     * This is the constructor of the abstract polygon button. It will set the
     * parent which can not be null. All other parameters can also be null.
     * Most of them will be set to default values.
     *
     * @param parent_ The parent element who has called this constructor.
     * @param colorActive_ Is the active color when the mouse is inside the
     * 		button.
     * @param colorActiveBorder_ Is the active border color when the mouse is
     * 		inside the button.
     * @param colorInactive_ Is the inactive color when the mouse is outside
     * 		the button.
     * @param colorInactiveBorder_ Is the inactive border color when the mouse
     * 		is outside the button.
     */
    @Deprecated
    protected APolygonButton(Component parent_
    		, Color colorActive_, Color colorActiveBorder_
    		, Color colorInactive_, Color colorInactiveBorder_)
    {
        this(parent_);

    	_colorActive = (colorActive_ == null) ? ViewConstant.COL_ACTIVE : colorActive_;
        _colorActiveBorder = (colorActiveBorder_ == null) ? ViewConstant.COL_ACTIVE_BORDER : colorActiveBorder_;
        _colorInactive = (colorInactive_ == null) ? ViewConstant.COL_INACTIVE : colorInactive_;
        _colorInactiveBorder = (colorInactiveBorder_ == null) ? ViewConstant.COL_INACTIVE_BORDER : colorInactiveBorder_;
    }

    /**
     * This is the constructor of the abstract polygon button. It will set the
     * parent which can not be null. All other parameters can also be null.
     * Most of them will be set to default values.
     *
     * @param parent_ The parent element who has called this constructor.
     * @param polygon_
     * @param colorActive_ Is the active color when the mouse is inside the
     * 		button.
     * @param colorActiveBorder_ Is the active border color when the mouse is
     * 		inside the button.
     * @param colorInactive_ Is the inactive color when the mouse is outside
     * 		the button.
     * @param colorInactiveBorder_ Is the inactive border color when the mouse
     * 		is outside the button.
     */
    @Deprecated
    protected APolygonButton(Component parent_, Polygon polygon_
    		, Color colorActive_, Color colorActiveBorder_
    		, Color colorInactive_, Color colorInactiveBorder_)
    {
        this(parent_, polygon_);

    	_colorActive = (colorActive_ == null) ? ViewConstant.COL_ACTIVE : colorActive_;
        _colorActiveBorder = (colorActiveBorder_ == null) ? ViewConstant.COL_ACTIVE_BORDER : colorActiveBorder_;
        _colorInactive = (colorInactive_ == null) ? ViewConstant.COL_INACTIVE : colorInactive_;
        _colorInactiveBorder = (colorInactiveBorder_ == null) ? ViewConstant.COL_INACTIVE_BORDER : colorInactiveBorder_;
    }

    /*
     * (non-Javadoc)
     * @see javax.swing.JComponent#paint(java.awt.Graphics)
     */
    @Override public void paint(Graphics g)
    {
    	if (_polygon == null)
        	return;

        if (_isActive)
        {
            g.setColor(_colorActiveBorder);
            g.drawPolygon(_polygon);
            g.setColor(_colorActive);
            g.fillPolygon(_polygon);
        }
        else
        {
            g.setColor(_colorInactiveBorder);
            g.drawPolygon(_polygon);
            g.setColor(_colorInactive);
            g.fillPolygon(_polygon);
        }

    	// don't call the super paint method as it will slow down the
    	// interation with the mouse button
        super.paint(g);
    }

    /**
     * Returns the current polygon.
     *
     * @return The current polygon is returned as an instance of the class
     * 		{@code java.awt.Polygon}.
     */
    @Deprecated
    public Polygon fetchPolygon()
    {
        return _polygon;
    }

    /**
     * Will set the current polygon. This can never be null. If it is null an
     * exception will be thrown.
     *
     * @param polygon_ Is the polygon to be set.
     */
    @Deprecated
    public void putPolygon(Polygon polygon_)
    {
    	if (polygon_ == null)
    		throw new IllegalArgumentException("The argument of the polygon is" +
    				" null");

    	_polygon = polygon_;
    }

    /**
     * Fetches the current parent parameter.
     *
     * @return The parent parameter is returned.
     */
    @Deprecated
    public Object fetchParent()
    {
        return _parent;
    }

    /**
     * Ask if this button is active.
     *
     * @return Returns a boolean value.
     */
    @Deprecated
    public boolean isActive()
    {
    	return _isActive;
    }

    /*
     * (non-Javadoc)
     * @see javax.swing.JComponent#getPreferredSize()
     */
    @Override public Dimension getPreferredSize()
	{
		return ViewConstant.DIMENSION_ACCELERATOR;
	}

	/*
	 * (non-Javadoc)
	 * @see javax.swing.JComponent#getMaximumSize()
	 */
    @Override public Dimension getMaximumSize()
	{
		return ViewConstant.DIMENSION_ACCELERATOR;
	}

	/*
	 * (non-Javadoc)
	 * @see javax.swing.JComponent#getMinimumSize()
	 */
    @Override public Dimension getMinimumSize()
	{
		return ViewConstant.DIMENSION_ACCELERATOR;
	}
}
/* end of file */