/*
 *
 * File: DESYToolTipManager.java
 * Date: Oct 29, 2006; 10:17:21 AM
 */
package de.desy.mst.libs.accelerator.view;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseMotionAdapter;

import javax.swing.JToolTip;
import javax.swing.JFrame;
import javax.swing.JLayeredPane;

/**
 * This is the desy tool tip manager.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: DESYToolTipManager.java 32894 2010-02-08 12:53:07Z walla $
 */
@Deprecated
public class DESYToolTipManager extends MouseMotionAdapter implements ActionListener
{
	/** This is a timer. This conflicts with another Timer which is included in Java 1.3 */
	protected javax.swing.Timer _timer;	// Name conflict with java.util.Timer in 1.3

	/** Is the last x coordinate of the displayed tool tip. */
	protected int _lastX = -1;

	/** Is the last y coordinate of the displayed tool tip. */
	protected int _lastY = -1;

	/** Is a boolean value which shows if the mouse has moved since the tool tip
	 * is displayed on screen. */
	protected boolean _isMoved = false;

	/** This is a counter for showing the tool tip on screen. If this pointer
	 * has reached a particular value the tool tip will be disabled. */
	protected int _counter = 0;

	/** This is the tool tip object.
	 * TODO: Under the javadoc documentation there exits a method called
	 * JComponent.createToolTip which returns a JToolTip object. This can be
	 * used for giving a short hints for the object which lies under the mouse.
	 */
	protected JToolTip _toolTip = new JToolTip(); // parent.getToolTip();

	/** The parant container. This is never null. */
    protected Container _parent = null;

    /**
     * Sets the tool tip with its parent container.
     *
     * @param parent_ This is the parent container.
     */
    @Deprecated
	public DESYToolTipManager(Container parent_)
    {
        if (parent_ == null)
            throw new IllegalArgumentException("The parent is null.");

        _parent = parent_;

        parent_.addMouseMotionListener(this);

		_toolTip.setTipText(null);
		if (parent_ instanceof JFrame)
			((JFrame) parent_).getLayeredPane().add(_toolTip, new Integer(1000));
		else if (parent_ instanceof JLayeredPane)
			parent_.add(_toolTip, new Integer(1000));
		else
			parent_.add(_toolTip);

		_toolTip.setVisible(false);
		_timer = new javax.swing.Timer(1000, this);
		_timer.start();
	}

	/*
	 * (non-Javadoc)
	 * @see java.awt.event.MouseMotionAdapter#mouseMoved(java.awt.event.MouseEvent)
	 */
	@Override public void mouseMoved(MouseEvent e)
    {
		_isMoved = true;
		_counter = -1;
		_lastX = e.getX();
		_lastY = e.getY();
		if (_toolTip.isVisible()) {
			_toolTip.setVisible(false);
			_toolTip.getParent().repaint();
		}
	}

	/*
	 * (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e)
    {

		if (_isMoved || _counter==0 || _toolTip.getTipText()==null) {
			if (_toolTip.isVisible())
				_toolTip.setVisible(false);
			_isMoved = false;
			return;
		}

		if (_counter < 0) {
			_counter = 4;
			_toolTip.setVisible(true);
			Dimension d = _toolTip.getPreferredSize();
//            Rectangle rec = _parent.getBounds();
//            if (d.width - rec.width < 0)
//                _toolTip.setBounds(_lastX - rec.width, _lastY + 20,
//                        d.width, d.height);
//            else
            _toolTip.setBounds(0, 0,
                    d.width, d.height);
//
//            _toolTip.setBounds(_lastX, _lastY+20,
//                        d.width, d.height);
		}

		_counter--;
	}

	/**
	 * Returns the java tool tip object.
	 *
	 * @return A tool tip object is returned. This is never null.
	 */
    @Deprecated
    public JToolTip getToolTip()
    {
        return _toolTip;
    }
}
/* end of file */