/**
 * Jan 29, 2008 - Jan 29, 2008	ws:	Creation from extract Interface on MstApp
 * Jan 13, 2009 - Jan 13, 2009	ws:	getHelpMgr von MstApp hochfaktoriert
 */
package de.desy.mst.libs.framework.mstapp;

import de.desy.mst.libs.framework.mstapp.hilfe.HelpMgr;
import de.desy.mst.libs.framework.mstapp.menu.IPopupMenuMgr;
import de.desy.mst.libs.framework.mstapp.mode.MaschineMgr;

/**
 * Kernfunktionen von MstApp werden vor der (langsamen fehleranfaelligen)
 * vollstaendigen Konstruktion von MstApp gebraucht. Zum Beispiel um im
 * Crashfall die Logbucheintraege anzeigen zu koennen.
 * <br>
 * Wird von MstApp und MstAppKernel Implementiert
 * @author ws
 * @version 1.0.0
 */
public interface IMstAppKernel {
	/**Startparameter in geparster Form*/
	public abstract ParamDecoder getStartParameter();
	/**
	 * @return	den MaschinenMgr fuer detailiertere Maschinenoperationen, wie
	 *  		Aendern von erlaubten Maschinen
	 */
	public abstract MaschineMgr getMaschineMgr();
	/**not null fuer Kontext sensitive Menues*/
	public abstract IPopupMenuMgr getPopUpMenuMgr();
	/**not null but maybe surrogat*/
	public abstract HelpMgr 		getHelpMgr();
}