/**
 * Mar 29, 2010 - Mar 29, 2010	ws:	getHelpUrl() no double http prefix
 * 									getHelpBase() connected to single source
 * Mar 30, 2010 - Mar 30, 2010	ws:	isCompleteAddress(..) fixed NullPointer Problem
 *									getHelpUrl() null help emergency handling
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf;

import de.desy.mst.libs.framework.mstapp.hilfe.PfadeBKRWiki;


/**
 * Als Vorbereitung fuer Erweiterungen
 * @author labudda
 *
 */
public abstract class AApp implements IApp {

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.appinf.IApp#getHelpBase()
	 */
	@Override public String getHelpBase() {return PfadeBKRWiki.BKR_WIKI_ADDRESS;}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.appinf.IApp#getHelpUrl()
	 */
	@Override public String getHelpUrl() {
		/**AnLa needs for *.jnlp a complete path, do remove path duplications*/
		final String help = this.getHelp();
		if(help == null)			//Juri Case
			return getHelpBase();	//not nice, but does something noncrashing not too unreasonable
		else
			return isCompleteAddress(help) ? help : this.getHelpBase() + help;
	}

	private boolean isCompleteAddress(final String sURL) {
		return (sURL!= null && sURL.contains("://"));
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApp#getFileTimestamp()
	 */
	@Override public String getFileTimestamp() {
		// TODO Not implemented, yet
		return "";
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApp#getReleaseReason()
	 */
	@Override public String getReleaseReason() {
		// TODO Not implemented, yet
		return "";
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApp#getReleaseTimestamp()
	 */
	@Override public String getReleaseTimestamp() {
		// TODO Not implemented, yet
		return "";
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.appinf.IApp#isInformationValid()
	 */
	@Override public boolean isInformationValid() {
		return this.getContact().getName() != null;
	}


}
