/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf;

/**
 * @author labudda
 * Stellt sicher, dass die hier benutzten Properties ueberall identisch geschrieben werden.
 * Die Methoden sind nur Kurzformen der bekannten System.getProperties API
 *
 */
public enum CustomSystemProperty {
	/**
	 * Definiert die implementierende factory von aussen (zum Debug) definiert werden koennen.
	 * Ueberschreibt die Auswahl in Automatic. Die Factory soll auf isValid mit true antworten, 
	 * wenn der Name der Factory definiert ist. 
	 */
	ApplicationKindFactory;
	
	public boolean isAvailable(){
		return System.getProperties().containsKey(this.name());
	}
	
	public String getValue() {
		return System.getProperties().getProperty(this.name(), null);
	}
}
