/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf.client;



class JNLPClassLoaderDelegated extends Delegated implements IJNLPClassLoader {
	static String JNLP_CLASS = "com.sun.jnlp.JNLPClassLoaderUtil";
	public JNLPClassLoaderDelegated() {
		super(JNLPClassLoaderDelegated.JNLP_CLASS, "getInstance");
	}
	
	
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IJNLPClassLoader#getLaunchDesc()
	 */
	@Override public ILaunchDesc getLaunchDesc() throws UnsupportedOperationException, IllegalArgumentException {
		//final DownloadEngineDelegated justTest = new DownloadEngineDelegated();
		final Object launchDesc = this.getDelegatedResult("getLaunchDesc");
		return new LaunchDescDelegate(launchDesc);
	}
	
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IJNLPClassLoader#getJarFile(java.lang.String)
	 */
	@Override public java.util.jar.JarFile getJarFile(final java.net.URL url) throws UnsupportedOperationException, IllegalArgumentException {
		return (java.util.jar.JarFile) this.getDelegatedResult("getJarFile", url);
	}
	
}