/**
 * Mar 19, 2007 - Apr 11, 2007	ws: creation from scratch
 * May  9, 2007 -				ws: added convertToFileForm(...)
 * Apr 18, 2008 - Apr 18, 2008	ws: added about box support
 * Jun  5, 2008 - Jun  5, 2008	ws:	about nach AL Rezept 2008-06-04 eMail
 * Aug 15, 2008 - Aug 15, 2008	ws: appName -> alName in java doc
 * Dec  2, 2008 - Dec  2, 2008	ws:	center DialogShowingURI to guessed MstFrameMain
 * Jan  8, 2009 - Jan  8, 2009	ws:	added calcAnnotatedTitle() zu About Box
 * Jan 13, 2009 - Jan 13, 2009	ws:	added public createHilfePfadMenuesAbout(showInBrowser)
 * Feb 23, 2009	- Feb 23, 2009	ws:	added: addDeveloperSpecificHelp
 * Sep  1, 2009 - Sep  8, 2009	ws:	Hilfe zeigt nun ins BKRWiki and supports PrefHilfe
 * Oct 27, 2009 - Oct 30, 2009	ws:	BKRWiki: kann AppSpezifische URL Root angeben
 * Feb 25, 2010	- Mar  4, 2010	ws:	start support of AnLa Type about box
 * Apr 28, 2010 - Apr 28, 2010	ws:	allow modal = FALSE for crashframe
 * Nov  3, 2010 - Nov  3, 2010	ws:	added support for Tarantula
 */
 
package de.desy.mst.libs.framework.mstapp.hilfe;

import java.awt.Component;
import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicReference;

import javax.swing.JDialog;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstFrameMain;
import de.desy.mst.libs.framework.mstapp.hilfe.PfadeBKRWiki.ISysAppDataSource;
import de.desy.mst.libs.framework.mstapp.ini.PfadeIni;
import de.desy.mst.libs.framework.mstapp.ini.TabDataHome;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.mode.IMaschineObserver;
import de.desy.mst.libs.framework.mstapp.mode.Maschine;
import de.desy.mst.libs.framework.mstapp.mode.MaschineMgr;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.util.gui.DialogShowingHTML;
import de.desy.mst.libs.framework.mstapp.util.gui.JDialogWithCloseOnEscape;

/**
 * entry: initHelpMenu(final JMenu menuHelp)
 * @author ws
 * version 1.0.0
 */
public class HelpMgr {
	/**contains all Tarantula Interface related stuff only "createTarantulaJMenuItem" is used*/
	private static final class JDialogTarantula extends JDialogWithCloseOnEscape {
		private static final long serialVersionUID = 1L;
		
//		private static final String CLASS_NAME_EXTERNAL_COMPONENT = "de.desy.acop.displayers.AcopSpider";
		private static final String CLASS_NAME_EXTERNAL_COMPONENT = "de.desy.acop.displayers.tarantula.TarantulaPanel";
		private static final Component CmpTarantula = createTarantula();
		private static Component createTarantula() {
			try {return (Component) Class.forName(CLASS_NAME_EXTERNAL_COMPONENT)
										 .getConstructor()
										 .newInstance(new Object[0]);
			}catch(final Exception ex){return null;}
		}
		private static boolean hasTarantula() {return CmpTarantula != null;}
		public static JMenuItem createTarantulaJMenuItem() {
			final JMenuItem jMnuItem = new JMenuItem("Tarantula");
			jMnuItem.setToolTipText("<html>Zeigt:<br>Die Tine Superspinne Tarantula.<br>Tine Verbindungen werden in die Tiefe verfolgt.</html>");
			jMnuItem.setEnabled(JDialogTarantula.hasTarantula());
			if(jMnuItem.isEnabled())
				jMnuItem.addActionListener(new ActionListener(){
					@Override public void actionPerformed(final ActionEvent evt) {
						new JDialogTarantula().setVisible(true);
					}
				});
			return jMnuItem;
		}
		@SuppressWarnings("deprecation") private JDialogTarantula() {
			super(Main.getLastCreatedFrame(), "Tarantula", false);
			final Component cmp = CmpTarantula;
			if(cmp != null)
				this.add(cmp);
			this.pack();
			Main.centerToMstFrameMain(this);
		}
	}//END: JDialogTarantula

	private final class BKRWikiData implements ISysAppDataSource {
		private volatile String appPageName = null;
		private volatile String sysPageName = null;
		@Override public String getAppPageName   () {return this.appPageName;}
		@Override public String getSystemPageName() {return this.sysPageName;}
		private final void setSystemPageName(final String systemPageName) {
			this.sysPageName = systemPageName;
			recalculateMenuItems();	//after, since I need the changed info
		}
		private final void setAppPageName(final String appPageName) {
			this.appPageName = appPageName;
			recalculateMenuItems();	//after, since I need the changed info
		}
	}

	//-----------------------------------------------------------------------------

	public  final IHilfePfade   WEBSTART;
	public  final IHilfePfadeEx HILFESYSTEM;
	public  final IHilfePfade   INIDATEIEN;
	public  final IHilfePfade   JAVADOCS;

//http://doc.desy.de/elog/servlet/XMLlist3?
//file=/DOC/data/doc/common/applications/test/HelpTest/
//&xsl=/elogbook/xsl/elog-wiki3.xsl
//&picture=true

//HELPSYSTEM:
//http://doc.desy.de/elog/servlet/XMLlist3?file=/DOC/data/doc/DESY2/applications/elektronenstrahlkontrolle/d2energien&xsl=/elogbook/xsl/elog-wiki3.xsl&picture=true
//WebStart:
//http://mcalaunch.desy.de/webapps/Released/desy2/Elektronenstrahlkontrolle/D2Energien.jnlp

	private static final String ALLGEMEIN = "Allg.";
	private static final String KONTROLLSYSTEM = "Kontrollsystem";
	private static final String KONTROLLSYSTEM_URI = "http://adweb/mst/PETRA_III_Kontrollsystem/";

	private static final String TABELLEN = "Tabellen";
	private static final String TABELLEN2 = "berblick";

	private static final String HILFE = "Hilfe";
	private static final String WEB_START = "WebStart";
	private static final String INI_DATEI = "IniDatei";
	private static final String JAVA_DOC = "JavaDoc";

/*
	//	private static final String APPHELP_URI = "http://doc.desy.de/DOC/index.jsp?dir=";
	private static final String APPHELP_URI_PRE = "http://doc.desy.de/elog/servlet/XMLlist3?file=/DOC/data/doc";
	private static final String APPHELP_URI_SUF = "&xsl=/elogbook/xsl/elog-wiki3.xsl&picture=true";

	private static final String ABOUT = "about";
	private static final String HOME  = "home";

*/

//-----------------------------------------------------------------------------

	/**Zeigt den HTML Pfad im Browser an*/
	public static void show(final String htmlPfad) {
		try {
			final URI uri = createURI(htmlPfad);
			Desktop.getDesktop().browse(uri);
		} catch (final IOException ioE) {
			final String msg = "Kann die URI '"
				+ htmlPfad
				+ "' nicht im Browser anzeigen.";
			Logger.SWFW.warn(msg, ioE);
		}
	}
	/**Convertiert DateiPfade zu HTML DateiPfade*/
	public static String convertToFileForm(final String dateiPfad) {
		final String sollPrefix = "file:///";
		final String prefix = dateiPfad.contains(sollPrefix) ? "" : sollPrefix;
		return prefix + dateiPfad.replace("\\", "/");
	}

//=============================================================================

	private final ApplicationInfo applicationInfo;
	private final BKRWikiData  bkrWikiSysAppDataSource = new BKRWikiData();
	private final AtomicBoolean isDisplayClassicalHelp = new AtomicBoolean(false);
	private final AtomicReference<IPreferences> prefHilfe = new AtomicReference<IPreferences>(null);
	private final AtomicReference<JMenu>		lastJMenuHilfe = new AtomicReference<JMenu>();
	private final AtomicReference<MaschineMgr>  lastMaschinMgr = new AtomicReference<MaschineMgr>();
//-----------------------------------------------------------------------------
	/**@param  applicationInfo  not null
	 * @throws NullPointerException  falls applicationInfo == null */
	public HelpMgr(final ApplicationInfo applicationInfo) {
		if(applicationInfo == null)
			throw new NullPointerException("Das applicationInfo darf nicht null sein.");
		this.applicationInfo = applicationInfo;
		this.WEBSTART    = new PfadeWebStart	(getApplicationInfo());
		this.HILFESYSTEM = new PfadeHilfeSystem	(getApplicationInfo());
		this.INIDATEIEN  = new PfadeIni			(getApplicationInfo());
		this.JAVADOCS    = new PfadeJavaDoc 	(getApplicationInfo());
	}
//-----------------------------------------------------------------------------
	/**never null*/
	public final ApplicationInfo getApplicationInfo() {return this.applicationInfo;}
	public boolean isDisplayClassicalHelp() {return this.isDisplayClassicalHelp.get();}
	public void setDisplayClassicalHelp(final boolean selected) {
		this.isDisplayClassicalHelp.getAndSet(selected);
		final JMenu lastMenuHilfe = this.lastJMenuHilfe.get();
		final MaschineMgr lastMaschineMgr = this.lastMaschinMgr.get();
		if(lastMenuHilfe != null && lastMaschineMgr != null)
			recalculateMenuItems(lastMenuHilfe, lastMaschineMgr.getMaschine());
	}
	public IPreferences getPreference() {
		if(this.prefHilfe.get() == null)
			this.prefHilfe.set(new PrefHilfe(this));
		return this.prefHilfe.get();
	}

	/**erzeugt ein standard Hilfe Menue mit Wurzel menuHelp*/
	public final void initHelpMenu(final JMenu menuHelp, final MaschineMgr maMgr){
		this.lastJMenuHilfe.set(menuHelp);
		this.lastMaschinMgr.set(maMgr);
		menuHelp.setText("Hilfe");
		if(maMgr != null)
			maMgr.registerIMaschineObserver(new IMaschineObserver(){
				@Override public void onMaschineChange(final Maschine neueMaschine) {
					recalculateMenuItems(menuHelp, neueMaschine);
				}
			});
	}
	public void addDeveloperSpecificHelp(final MstFrameMain frameMain, final String menueText, final String helpInHTML) {
		final JMenu menuHelp = frameMain.getJMenuHelp();
		final JMenuItem item = new JMenuItem();
		final String fullMenueText = calcSKatPrefix(HILFE) + menueText;
		item.setText(fullMenueText);
		item.addActionListener(new ActionListener(){
			@Override public void actionPerformed(final ActionEvent e) {
				DialogShowingHTML.createDialogShowingHTML(frameMain, fullMenueText, helpInHTML).setVisible(true);
			}
		});
		final int nCmps = menuHelp.getItemCount();
		final boolean hasCmpts = nCmps > 0;
		menuHelp.insert(item, hasCmpts ? 1 : 0);
	}
	/**public for CrashFrame UncaughtExceptionDialog to clone to JButton*/
	public JMenuItem createHilfePfadMenuesAbout(final boolean showInBrowser) {
		return createHilfePfadMenuesAbout(showInBrowser, false);
	}
	public JMenuItem createHilfePfadMenuesAbout(final boolean showInBrowser, final boolean modal) {
		return createHilfePfadMenuesAbout(HILFE, this.HILFESYSTEM, showInBrowser, modal);
	}

	/**leaf name for this particular application in the Bkr_wiki for example "Kicker:_Fehlermeldungen"*/
	public String getBKRWikiHilfe_AppPageName() {
		return getBkrWikiSysAppDataSource().getAppPageName();
	}
	/**leaf name for this particular application in the Bkr_wiki for example "Kicker:_Fehlermeldungen"*/
	public void setBKRWikiHilfe_AppPageName(final String pageName) {
		getBkrWikiSysAppDataSource().setAppPageName(pageName);
	}
	/**leaf name for this particular system in the Bkr_wiki"*/
	public String getBKRWikiHilfe_SubSystemPageName() {
		return getBkrWikiSysAppDataSource().getSystemPageName();
	}
	/**leaf name for this particular system in the Bkr_wiki"*/
	public void setBKRWikiHilfe_SubSystemPageName(final String pageName) {
		getBkrWikiSysAppDataSource().setSystemPageName(pageName);
	}
//-----------------------------------------------------------------------------
	@SuppressWarnings("deprecation")
	private Component getFrameMain() {return Main.getLastCreatedFrame();}
	private void recalculateMenuItems(){
		recalculateMenuItems(this.lastJMenuHilfe.get(), this.getMaschine());
	}
	private void recalculateMenuItems(final JMenu menuHelp, final Maschine neueMaschine) {
		removeHilfeMenuItems(menuHelp);
		addHilfeMenuItems(menuHelp, neueMaschine);
	}
	private void removeHilfeMenuItems(final JMenu menuHelp) {menuHelp.removeAll();}
	private void addHilfeMenuItems(final JMenu menuHelp, final Maschine maschine) {
		final boolean showInBrowser = true;
		menuHelp.add(createHilfePfadMenuesAbout(!showInBrowser));
		menuHelp.addSeparator();
		createBKRWikiPfadMenues(menuHelp, showInBrowser, maschine);
		menuHelp.add(initHelpMenuClassic());	
		menuHelp.addSeparator();
		menuHelp.add(JDialogTarantula.createTarantulaJMenuItem());
	}
	/**erzeugt ein pre BKRWiki Hilfe Menue mit Wurzel menuHelp*/
	private final JMenu initHelpMenuClassic(){
		final JMenu menuClassicHelp = new JMenu();
		final boolean showInBrowser = true;
		menuClassicHelp.setText("Altes Hilfe Men");
		final boolean displayClassicalHelp = isDisplayClassicalHelp();
		menuClassicHelp.setVisible(displayClassicalHelp);
		menuClassicHelp.setEnabled(displayClassicalHelp);

		menuClassicHelp.add(createHilfePfadMenuesAbout(!showInBrowser));
		menuClassicHelp.addSeparator();
		createHilfePfadMenues(menuClassicHelp, HILFE, this.HILFESYSTEM, showInBrowser);
		menuClassicHelp.addSeparator();
		menuClassicHelp.add(createHelpMenuDetails(showInBrowser));

		return menuClassicHelp;
	}

	private JMenu createHelpMenuDetails(final boolean showInBrowser) {
		final JMenu menu = new JMenu("Weitere Informationen ...");
		menu.add(createJMenuItem(ALLGEMEIN, KONTROLLSYSTEM, KONTROLLSYSTEM_URI, showInBrowser));
		menu.addSeparator();
		createHilfePfadMenues(menu, INI_DATEI, this.INIDATEIEN, showInBrowser);
		menu.addSeparator();
		menu.add(createJMenuItem(TABELLEN, TABELLEN2, TabDataHome.getHTTP_Root_Human(), showInBrowser));
		menu.addSeparator();
		createHilfePfadMenues(menu, JAVA_DOC, this.JAVADOCS, showInBrowser);
		menu.addSeparator();
		menu.add(createWebStartMenu());

		return 	menu;
	}

	private JMenuItem createWebStartMenu() {
		final JMenu menu = new JMenu("Hier knnen Programme gestartet werden.");
		final boolean showInBrowser = true;
		createHilfePfadMenues(menu, WEB_START, this.WEBSTART, showInBrowser);
		return menu;
	}
 
	private JMenuItem createHilfePfadMenuesAbout(final String sKat
											   , final IHilfePfadeEx hilfePfade
											   , final boolean showInBrowser
											   , final boolean modal) {
		final ApplicationInfo appInfo = this.getApplicationInfo();
		final String accelerator = appInfo.getAccelerator();
		final String subSystem = appInfo.getSubSystem();
		final String alName = appInfo.getShortFrameName();	//.getAppName() ist alt
		final String aboutBoxHTTP = hilfePfade.getAboutBoxHTTP(accelerator, subSystem, alName);

		final String mnuTitle = "Info (about)";
		final String completeMnuTitle = calcSKatPrefix(sKat) + mnuTitle;
		final JMenuItem mnuItem = new _HelpAbout(completeMnuTitle, aboutBoxHTTP).createMenuItem(modal);
		return mnuItem != null ? mnuItem : createJMenuItem(sKat, mnuTitle, aboutBoxHTTP, showInBrowser);
	}
	private void createHilfePfadMenues(final JMenu menuHelp, final String sKat, final IHilfePfade hilfePfade, final boolean showInBrowser) {
		final ApplicationInfo appInfo = this.getApplicationInfo();
		final JMenuItem app = createJMenuItem(sKat, "Applikation (" + appInfo.getAppName() + ")", hilfePfade.getDateiPfad(), showInBrowser);
		menuHelp.add(app);
		final JMenuItem sub = createJMenuItem(sKat, "Subsystem (" + appInfo.getSubSystem() + ")", hilfePfade.getSubsystemVerzeichnis(), showInBrowser);
		menuHelp.add(sub);
		final JMenuItem alg = createJMenuItem(sKat, "Allgemein",   hilfePfade.getSystemRoot(), showInBrowser);
		menuHelp.add(alg);
	}
	private void createBKRWikiPfadMenues(final JMenu menuHelp, final boolean showInBrowser, final Maschine maschine) {
		final String sKat = "BKR WIKI Hilfe";

		final PfadeBKRWiki hilfePfade = new PfadeBKRWiki(getBkrWikiSysAppDataSource(), getApplicationInfo());
		final ApplicationInfo appInfo = this.getApplicationInfo();
		menuHelp.add(createJMenuItem(sKat, "Allgemein",   hilfePfade.getSystemRoot(), showInBrowser));
		menuHelp.add(createJMenuItem(sKat, "Maschine ("    + maschine.getBkrWikiName() + ")", hilfePfade.getMaschineVerzeichnis(getMaschine()), showInBrowser));
		menuHelp.add(createJMenuItem(sKat, "Subsystem ("   + appInfo.getSubSystem() + ")", hilfePfade.getSubsystemVerzeichnis(),showInBrowser));
		menuHelp.add(createJMenuItem(sKat, "Applikation (" + appInfo.getAppName  () + ")", hilfePfade.getDateiPfad(), 			showInBrowser));
	}
	/**calculates the URI Address (String) of appPath*/
/*	private String calcAppHelpAdd(final String appPath, final String what) {
		return APPHELP_URI_PRE + appPath + "#" + what + APPHELP_URI_SUF;
	}
*/

	@SuppressWarnings("deprecation")	//besser waere MaschineMgr Referenz
	private Maschine getMaschine() {return Maschine.getMaschine();}
	private final BKRWikiData getBkrWikiSysAppDataSource() {return this.bkrWikiSysAppDataSource;}

	/**
	 * @param sKat		Kategorie:	zB Allgemein, Applikation, Daten
	 * @param sTitle				zB About, Home
	 * @param sUri		String der zugehoerigen WebAdresse
	 * @return			ein neues MenueItem, nie null
	 */
	private JMenuItem createJMenuItem(final String sKat, final String sTitle, final String sUri, final boolean showInBrowser) {
		final JMenuItem item= new JMenuItem(calcSKatPrefix(sKat) + sTitle);
		return configureJMenuItem(sUri, showInBrowser, item);
	}

	/**
	 * Uses existing item with fixed Text and adds actions, tooltips, enablement
	 * @param sUri		String der zugehoerigen WebAdresse
	 * @return			ein neues MenueItem, nie null
	 */
	private JMenuItem configureJMenuItem(final String sUri, final boolean showInBrowser, final JMenuItem item) {
		if(item == null )
			return item;
		if(sUri == null || sUri.length() == 0){
			/**simple way to ignore entries*/
			item.setEnabled(false);
			//item.setVisible(false);
			return item;
		}
		item.setToolTipText(sUri);
//		item.setSize(101, 21);

		ActionListener listener = null;
		if( (!showInBrowser) || Desktop.isDesktopSupported()) {
			listener = createBrowserActionListener(sUri, showInBrowser);
		}else{
			//Idee implement initAndRegisterHelpMenu in extra class
			//impl Idee: Eckel p 845 HTML on Swing Componenst via URL as in ConfigMgr
			final String msg = "Hilfe fr '"
							 + item.getText()
							 + "' kann nicht angezeigt werden"
							 + " denn (!Desktop.isDesktopSupported()).";
			Logger.SWFW.warn(msg);
		}
		if(listener != null){
			item.addActionListener(listener);
		}
		item.setEnabled(listener != null);
		return item;
	}

	private String calcSKatPrefix(final String sKat) {return sKat + ": ";}

	private ActionListener createBrowserActionListener(final String sUri, final boolean showInBrowser) {
		return new ActionListener() {
			@Override public void actionPerformed(final ActionEvent evt) {
				if(showInBrowser)
					openInBrowser(sUri);
					//direkt oeffen falls != *.htm* wuerde erst mal das
					//Erzeugen einer Datei von der Webadresse erfordern
					//Also lass ich den Default Browser es tun
					//Im Cache geht das sicherlich besser.
				else
					openInFrame(Main.calcAnnotatedTitle("Info (About)"), sUri);
			}
			private void openInBrowser(final String sUri) {
				try {
					Desktop.getDesktop().browse(createURI(sUri));
				} catch (final IOException ioE) {
					final String msg = "Kann die URI '"
									 + sUri
									 + "' nicht im Browser anzeigen.";
					Logger.SWFW.warn(msg, ioE);
				}
			}
			private void openInFrame(final String title, final String sUri) {
				final JDialog dialog = DialogShowingHTML.createDialogShowingURI(getFrameMain(), title, sUri);
				dialog.setVisible(true);
			}
		};
	}

	/**non null on success*/
	private static URI createURI(final String sUri) {
		try {
			return new URI(sUri);
		} catch (final URISyntaxException e) {
			Logger.SWFW.warn("Kann die URI '" + sUri + "' nicht erzeugen.", e);
			return null;
		}
	}
}
