/**
 * Sep  1, 2009 - Sep  1, 2009	ws:	Creation from scratch
 * Sep 27, 2009 - Sep 28, 2009	ws:	SYSTEM_ROOT nachgepflegt
 * Oct 27, 2009 - Oct 29, 2009	ws:	BKRWiki: kann AppSpezifische URL Root angeben
 */
package de.desy.mst.libs.framework.mstapp.hilfe;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.mode.Maschine;

/**
 * Zeigt auf den BKR WIKI der Maschine
 * <br> rein passive Klasse
 * <br> ISysAppDataSource erlaubt HelpMgr to transparently apply changes
 * 		PfadeBKRWike will not actively change state
 * <br> "extends AHilfePfade" kept for pseudo compatibility most certainly nonsense
 * @author ws
 * @version 1.0.0
 */
public class PfadeBKRWiki extends AHilfePfade {
	/**pp*/interface ISysAppDataSource{
		/**leaf name for this particular application in the Bkr_wiki for example "Kicker:_Fehlermeldungen"*/
		public String getAppPageName();
		/**leaf name for this particular system in the Bkr_wiki"*/
		public String getSystemPageName();
	}
	public  static final String BKR_WIKI_ADDRESS = "http://bkr-wiki.desy.de/"; //Fuer AnLa AboutBox
//=============================================================================
	private static final String KONTROLLSYSTEME_SUFFIX = ":_Kontrollsysteme";
	private static final String SYSTEM_ROOT = BKR_WIKI_ADDRESS + "index.php/"; // "Hauptseite";
//=============================================================================
	private final ISysAppDataSource sysAppDataSource;
//-----------------------------------------------------------------------------
	public PfadeBKRWiki(final ISysAppDataSource sysAppDataSource, final ApplicationInfo applicationInfo) {
		super(applicationInfo);
		this.sysAppDataSource = sysAppDataSource != null ? sysAppDataSource
							  : new ISysAppDataSource(){
									@Override public String getAppPageName   () {return null;}
									@Override public String getSystemPageName() {return null;}

		};
	}
	@Deprecated public PfadeBKRWiki(final ApplicationInfo applicationInfo) {
		this(null, applicationInfo);
	}
//-----------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfade#getAppOrALName(de.desy.mst.libs.framework.mstapp.ApplicationInfo)
	 */
	@Override public String getAppOrALName(final ApplicationInfo applicationInfo) {
		return applicationInfo.getShortFrameName();
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.IHilfePfade#getDateiPfad(java.lang.String, java.lang.String, java.lang.String)
	 */
	@Override public String getDateiPfad(final String accelerator, final String subSystem, final String appName) {
		final String appPageName = this.sysAppDataSource.getAppPageName();
		return appPageName == null ? null : getSystemRoot() + appPageName;
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.IHilfePfade#getSubsystemVerzeichnis(java.lang.String, java.lang.String)
	 */
	@Override public String getSubsystemVerzeichnis(final String accelerator, final String subSystem) {
		final String systemPageName = this.sysAppDataSource.getSystemPageName();
		return systemPageName == null ? null : getSystemRoot() + systemPageName;
	}

	public String getMaschineVerzeichnis(final Maschine maschine) {
		return maschine.hasBKRWikiAcceleratorWithControlsPage() ?
				getSystemRoot() + maschine.bkrWikiName + KONTROLLSYSTEME_SUFFIX
				:
				null;
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.IHilfePfade#getSystemRoot()
	 */
	@Override public String getSystemRoot() {return SYSTEM_ROOT;}

//=============================================================================
//
//	/**
//	 * Beschleuniger von http://mcalaunch.desy.de/webapps/released/
//	 * <br> mit Mapping zu BKR Wiki Beschleuniger
//	 */
//	private enum AccAnLa{
//		  auxiliary
//		, common
//		, desy2
//		, doris
//		, flash
//		, libs
//		, linac2
//		, petra
//		, pex
//		, pitz;
//	}
//	private enum AccBKR{
//		  LINAC_II
//		, PIA
//		, DESY_II
//		, DORIS_III
//		, PETRA_III
//		, FLASH;
//	}
}
