/**
 * Sep 7, 2009 - Sep 7, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.hilfe;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanelEinfach;

/**
 * Zum An und Ausschalten der klassischen Hilfe (default aus)
 * @author ws
 * @version 1.0.0
 */
class PrefHilfePanel extends APrefClientPanelEinfach{
	private static final long serialVersionUID = 1L;
//=============================================================================
	private final JCheckBox cBox;
	private final HelpMgr hMgr;
//-----------------------------------------------------------------------------
	PrefHilfePanel(final HelpMgr hMgr, final IPrefContainer prefContainer) {
		super(prefContainer);
		this.hMgr = hMgr;
		this.cBox = createCBox();
		this.add(getCBox());
		system2Gui();
	}
//-----------------------------------------------------------------------------
	@Override public void onDispose() {/*nothing to dispose of*/}
	@Override public void onReset() 					{system2Gui();}
	@Override public void onSet  () throws Exception	{gui2System();}
	//-----------------------------------------------------------------------------
	private final JCheckBox getCBox() {return this.cBox;}
	private final HelpMgr   getHelpMgr() {return this.hMgr;}
	private void system2Gui() {getCBox().setSelected(getHelpMgr().isDisplayClassicalHelp());}
	private void gui2System() {getHelpMgr().setDisplayClassicalHelp(getCBox().isSelected());}
	private JCheckBox createCBox() {
		final JCheckBox cBox = new JCheckBox("Klassisches Hilfemen anzeigen.");
		cBox.addItemListener(new ItemListener(){
			@Override public void itemStateChanged(final ItemEvent evt) {
				getPrefContainer().setChanged(isChanged());
			}
		});
		return cBox;
	}
	private boolean isChanged() {
		return getCBox().isSelected() != getHelpMgr().isDisplayClassicalHelp();
	}
}
