/**
 *  Created on 	Aug  9, 2005 - Aug 19, 2005
 *  			Feb 21, 2006 - Feb 21, 2006 Flache Outputs, appName -> tabId bezeichnung, cosmetics
 *  ws: Jul  4, 2007 - Jul  4, 2007 update XTor
 *	ws: Aug 29, 2007 - Sep  3, 2007	String appName -> ApplicationInfo appInfo	
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;

/**
 * Alle noetigen Daten um eine Tabelle zu laden.
 * Ja ich weiss, Tabelle ist deutsch und der Rest ist Englisch.
 * 
 * @author ws 
 * @version 1.0.0
 */
public class BaseDataForTabelle<FR extends IIniFileRoot> extends ABaseData<FR> {
    public static final String FILETYP = "Tabellen Daten Settings";
    public final String SHORTDESCRIPTION;
//=============================================================================
    /**
     * tabId entspricht pseudo appName
     * @throws NullpointerException
     */
    BaseDataForTabelle(final String tabId, final FR defaultFileRoot) {
    	//tabId entspricht pseudo appName
    	super(tabId, ApplicationInfo.createSystemAppInfo(tabId));
    	this.SHORTDESCRIPTION = FILETYP + ": " + tabId;
    	setFileRoot(defaultFileRoot);
    } 
//=============================================================================
    @Override protected String calcFileName(final String fileName) {
        return LocalHome.calcLocalPath(TabDataHome.SERVICE_NAME, "", fileName, FILE_SUFFIX);
    }
    @Override protected String calcWebAddress() {
        return TabDataHome.calcWebAddress(getAppName());
    }
    @Override protected String calcFileTyp() {
        return FILETYP;
    }
    @Override public String getShortDescription() {
        return this.SHORTDESCRIPTION;
    }
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.ini.ABaseData#onNewIniAvailable(java.lang.Object)
	 */
	@SuppressWarnings("unchecked") //for: (FR)iniBaumRoot
	@Override public void onNewIniAvailable(final Object iniBaumRoot) {
		if(iniBaumRoot instanceof IIniFileRoot){
			this.setFileRoot((FR)iniBaumRoot);
		}else if(iniBaumRoot == null){
			//do nothing
		}else{
			final String errMsg = "iniBaumRoot is not of Type '"
						  + IIniFileRoot.class.getName() 
						  + "', but of Type '"
						  + iniBaumRoot.getClass().getName()
						  + "'.";
			throw new IllegalArgumentException(errMsg);
		}
	}
}
