/**
 *  Aug  9, 2005 - Sep  2, 2005 Created on 	
 *  Nov 16, 2005 - Nov 18, 2005 Authenticator Support for Password protected sites, createDefaultTabelle to package from private
 *  Mar 30, 2007 - ... 			ws:	added support for HTTP_ROOT_HUMAN
 *  Jun 25, 2015 - Jun 25, 2015	ws:	DEFAULT_TABELLE with some generics annotiation
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.net.Authenticator;
import java.net.PasswordAuthentication;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.tabellendaten.AlleTabellen;
import de.desy.mst.libs.framework.mstapp.tabellendaten.Tabelle;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry;

/**
 * Basisdaten zu den Tabellen Daten Repository
 * 
 * @author ws
 * @version 1.0.0
 */
public class TabDataHome {
	public  static final String  SERVICE_NAME    = "TabData";
	static final Tabelle<Integer,  AEntry<Integer>> DEFAULT_TABELLE = createDefaultTabelle();
	
    private static final String SERVERNAME = "mstweb.desy.de";
    private static final String HTTP_BASE_ADDRESS = "http://" + SERVERNAME + "/";
    private static final String HTTP_SRV_ADDRESS = "Petra3XML";
    private static final String HTTP_ROOT_HUMAN = HTTP_BASE_ADDRESS + "TabellenDatenForm.htm";
    
    static {
    	Authenticator.setDefault(
    			new Authenticator(){
					@Override protected PasswordAuthentication getPasswordAuthentication() {
						return new PasswordAuthentication("TabReader"
														, new char[]{'G','e','h','e','i','m','0','5'});//"Geheim05"
					}
    				;}
    	);
    }

//=============================================================================    

    /**@return Returns the ServerName.*/
    public static final String getServerName() {
        return SERVERNAME;
    }
    /**@return Returns the Http_Base_Address.*/
    public static final String getHttp_Base_Address() {
        return HTTP_BASE_ADDRESS;
    }
	public static final String getHTTP_SRV_ADDRESS() {
		return HTTP_SRV_ADDRESS;
	}
	/**Damit Menschen via Browser zu den Tabellen navigieren koennen*/
	public static final String getHTTP_Root_Human() {
		return HTTP_ROOT_HUMAN;
	}
 

	/**
     * @param abfrage ...z.B. "StatusXML1+2"
     */
    public static final String calcWebAddress(final String abfrage) {
        return (HTTP_BASE_ADDRESS + HTTP_SRV_ADDRESS + "?SQL=" + abfrage);
    }

    public static boolean isReachable( ){
        return WebHome.isReachable(getServerName());
    }

    /**
     * Bitte nicht direkt benutzen, sondern AlleTabellen (checked)
     * @throws UnsupportedOperationException, if not called by AlleTabellen
     */
    @SuppressWarnings("rawtypes") public static Tabelle getTabelleImplementation(final String tabId) {
    	final String msg = TabDataHome.class.getSimpleName() 
    			         + ".getTabelleImplementation(" + tabId + ") "
    			         + "will soon be turned off.";
		Logger.SWFW_.warn(msg);
		//TODO Error Handling msgRec == a global one, ....
		XMLUtil.checkIsCalledByClass(AlleTabellen.class.getName());
		ABaseData<? extends IIniFileRoot> baseData;
		baseData = new BaseDataForTabelle<IIniFileRoot>(tabId, DEFAULT_TABELLE);
		final IniFileIOMgr fileIOMgr = new IniFileIOMgr(baseData, null/*msgRec*/);
		final IIniFileRoot result = fileIOMgr.read();
		return (Tabelle) result;
	}
	static Tabelle<Integer,  AEntry<Integer>> createDefaultTabelle() {
		return new Tabelle<Integer,  AEntry<Integer>>("[[[defaultTabelle]]]");
	}
}
