package de.desy.mst.libs.framework.mstapp.io;
//=============================================================================
/**
 * &Filename    DataError.java
 * &Projectname io
 * &Typename    Error
 * &date        Mar 19, 2008
 * &author      J. Maa -mcs1-
 */
//=============================================================================
public class DataError implements Cloneable {
	  private int code = 0;
	  private String text = null;

	  public DataError(int pCode, String pText) {
	    this.code = pCode;
	    this.text = pText;
	  }
	  //---------------------------------------------------------------------------
	  /**
	   * Liefert den ErrorCode (FehlerNummer)
	   * @return Returns the code.
	   * &author J. Maa -mcs1-
	   */
	  /*
	   * Vers		Date				Description
	   *  01	Jan 21, 2008	Methode erstellt
	   */
	  //---------------------------------------------------------------------------
	  public int getCode() {
	    return this.code;
	  }
	  //---------------------------------------------------------------------------
	  /**
	   * Setzt den ErrorCode (FehlerNummer)
	   * @param code The code to set.
	   * &author J. Maa -mcs1-
	   */
	  /*
	   * Vers		Date				Description
	   *  01	Jan 21, 2008	Methode erstellt
	   */
	  //---------------------------------------------------------------------------
	  public void setCode(int code) {
	    this.code = code;
	  }
	  //---------------------------------------------------------------------------
	  /**
	   * Liefert den Errortext
	   * @return Returns the text.
	   * &author J. Maa -mcs1-
	   */
	  /*
	   * Vers		Date				Description
	   *  01	Jan 21, 2008	Methode erstellt
	   */
	  //---------------------------------------------------------------------------
	  public String getText() {
	    return this.text;
	  }
	  //---------------------------------------------------------------------------
	  /**
	   * Setzt den Errortext
	   * @param text The text to set.
	   * &author J. Maa -mcs1-
	   */
	  /*
	   * Vers		Date				Description
	   *  01	Jan 21, 2008	Methode erstellt
	   */
	  //---------------------------------------------------------------------------
	  public void setText(String text) {
	    this.text = text;
	  }

	  @Override public DataError clone() {
	    try {
	      DataError cpyDataError = (DataError) super.clone();

	      cpyDataError.code = this.code;
	      cpyDataError.text = this.text;
	      return cpyDataError;

	    } catch (CloneNotSupportedException e) {
	      e.printStackTrace();
	      return null;
	    }

	  }

}
