/**
 * Jan 11, 2008 - Jan 11, 2008	ws:	Creation from Extract Interface of
 * 									LogAppenderBuffer
 * Jun 10, 2008 - Jun 16 2008	ws: support reloadAllData(), toString() enforced
 */
package de.desy.mst.libs.framework.mstapp.logging;

import java.io.IOException;
import java.util.List;

import de.desy.mst.libs.framework.mstapp.logging.appender.ILogAppenderKern;

/**
 * Damit ILogAppenderKern'e auf eine definierte Weise
 * mit Logging Quellen interagieren koennen.
 *
 * @author ws
 * @version 1.0.0
 */
public interface ILogProvider {

	/**
	 * @param logAppenderKern not null Kunde dieses Providers
	 */
	public abstract boolean register(final ILogAppenderKern logAppenderKern);

	/**
	 * @param logAppenderKern um Memory schonen zu koennen
	 */
	public abstract boolean deregister(final ILogAppenderKern logAppenderKern);

	/**
	 * @param appender einfache Info zur Registrierei
	 */
	public abstract boolean isRegistered(final ILogAppenderKern appender);

	/**
	 * @return	liefert alle vorhandenen Messages (keine Registrierung noetig)
	 */
	public abstract List<LogMsg> getMessages();

	/**
	 * @param index	0 kleinergleich index kleiner getSize()
	 * @return	liefert Messages mit Index oder null
	 * 			(keine Registrierung noetig)
	 */
	public abstract LogMsg getMessage(final int index);

	/**
	 * @return	liefert den maximal gueltigen index (MessageCount im Provider)
	 */
	public abstract int getSize();

	/**versucht die Daten frisch zu laden*/
	public abstract void reloadAllData() throws IOException;

	/**erzwinge gute Beschreibung zum Debuggen*/
	@Override public abstract String toString();
}