/**
 *  Created on  Aug 22, 2006
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.awt.BorderLayout;

import javax.swing.JPanel;

import de.desy.mst.libs.framework.mstapp.logging.EinfacherLogFormatter;
import de.desy.mst.libs.framework.mstapp.logging.LogLvl;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.util.IFormatAsString;

import javax.swing.JTable;
import javax.swing.JTextField;

/**
 * Detailierte Darstellung einer LogMsg<br>
 * Insbesondere soll hier ein vollstaendiger Trace eines "Throwable" zu sehen sein.
 * 
 * @author ws
 *
 */
class JPanel_LogMsg_MitTable extends JPanel {
	private static final long serialVersionUID = 1L;
	
	private final IFormatAsString<Throwable> throwableFormatter = new IFormatAsString<Throwable>(){
		final EinfacherLogFormatter einfacherLogFormatter = new EinfacherLogFormatter();  //  @jve:decl-index=0:
		@Override public String format(final Throwable t) {
			final String string = (t == null) ? ("") : (this.einfacherLogFormatter.throwableFormat(t));
			return string;
		}
		
	};
	private boolean didAutoColumnWidthOnRealData = false;
	private LogMsgTableModel tableModel 	= null;  
	private JTable jTableLogMsg 			= null;	//  @jve:decl-index=0:
	private JTextField jTextFieldMessage 	= null;
	private JTextField jTextFieldThrowable 	= null;
	
//=============================================================================
	
	public JPanel_LogMsg_MitTable() {
		super();
		this.setMsg(new LogMsg(LogLvl.debug, Logger.SWFW, "For Debugging only"));
		initialize();
	}
	public JPanel_LogMsg_MitTable(final LogMsg msg) {
		super();
		this.setMsg(msg);
		initialize();
	}
	
//=============================================================================
		
	public final LogMsg	getMsg() 					{return getTableModel().getMsg();}
	public final void	setMsg(final LogMsg msg)	{
		getTableModel().setMsg(msg);
		if((msg != null) && (!this.didAutoColumnWidthOnRealData)){
			this.autoColumnWidthOnRealData(msg);
		}
		if(msg == null)	{this.setTexte("", "");}
		else			{this.setTexte("" + msg.getMessage(), this.throwableFormatter.format(msg.getThrowable())/*"" + msg.getThrowable())*/);}
	}
	public void autoColumnWidthOnRealData(final LogMsg msg) {
		this.didAutoColumnWidthOnRealData = true;
//		final TableColumnModel columnModel = this.getJTableLogMsg().getColumnModel();
//		final LogMsgTableModel tableModel = getTableModel();
//		for(int i = 0; i < tableModel.getColumnCount(); i++){
//			final TableColumn column = columnModel.getColumn(i);
//			final String string = tableModel.getValueAt(1,1).toString();
//			FontRenderContext frc = null;
//			final Rectangle2D stringBounds = getJTableLogMsg().getFont().getStringBounds(string, frc); 
//			column.setPreferredWidth((int)stringBounds.getWidth());
//		}
	}
 
//=============================================================================
		
	private void setTexte(final String sMessage, final String sThrowable) {
		getJTextFieldMessage  ().setText("" + sMessage  );
		getJTextFieldThrowable().setText("" + sThrowable);
	}

//-----------------------------------------------------------------------------
			
	private void initialize() {
		this.setSize(300, 200);
		this.setLayout(new BorderLayout());
		this.add(getJTableLogMsg(), BorderLayout.NORTH);
		this.add(getJTextFieldMessage(), BorderLayout.CENTER);
		this.add(getJTextFieldThrowable(), BorderLayout.SOUTH);
	}

	private JTable getJTableLogMsg() {
		if (this.jTableLogMsg == null) {
			this.jTableLogMsg = new JTable(this.tableModel);
			this.jTableLogMsg.setAutoCreateColumnsFromModel(true);
		}
		return this.jTableLogMsg;
	}

	private LogMsgTableModel getTableModel() {
		if(this.tableModel == null){
			this.tableModel = new LogMsgTableModel();			
		}
		return this.tableModel;
	}
	private JTextField getJTextFieldMessage() {
		if (this.jTextFieldMessage == null) {
			this.jTextFieldMessage = new JTextField();
		}
		return this.jTextFieldMessage;
	} 
	private JTextField getJTextFieldThrowable() {
		if (this.jTextFieldThrowable == null) {
			this.jTextFieldThrowable = new JTextField();
		}
		return this.jTextFieldThrowable;
	}
}
