/**
 *  Created on  Aug 22, 2006 - Aug 23, 2006	ws
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import javax.swing.table.AbstractTableModel;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;

/**
 * @author ws
 *
 */
class LogMsgTableModel extends AbstractTableModel{
	private static final long serialVersionUID = 1L;
	private static final String[] columnNames = 
		{"Nr.", "Level", "Datum", "Applikation", "PC-Name", "Kategorie", "Run Id"};

	private LogMsg msg = null;
	
//=============================================================================	

	@Override public int getColumnCount() {return columnNames.length;}
	@Override public int getRowCount() 	{return 2;}
	@Override public Object getValueAt(final int rowIndex, final int columnIndex) {
		final LogMsg msg = getMsg();
		
		     if(rowIndex    == 0   ) 	{return columnNames[columnIndex];}
		else if(msg         == null) 	{return "";}
		else if(columnIndex == 0   ) 	{return Long.valueOf(msg.getNr());}
		else if(columnIndex == 1   ) 	{return msg.getLevel();}
		else if(columnIndex == 2   ) 	{return MstDateFormat.ISO.format(msg.getDate());}
		else if(columnIndex == 3   ) 	{return msg.getApplikation();}
		else if(columnIndex == 4   ) 	{return msg.getPcName();}
		else if(columnIndex == 5   ) 	{return msg.getKategorie();}
		else if(columnIndex == 6   ) 	{return msg.getRunId();}
		else  							{return "Huch (" + rowIndex + ", " + columnIndex + ")";}
	}
	public final LogMsg	getMsg() 					{return this.msg;}
	public final void	setMsg(final LogMsg msg)	{
		this.msg = msg; 
		this.fireTableRowsUpdated(1, 1);
	}
}