/**
 *	Jul 23, 2009 - Jul 23, 2009	ws:	creation from scratch
 *	Sep 22, 2009 - Sep 22, 2009	ws: for system infos selfmap 
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.util.Iterator;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.MstLog4TineLog_Facade;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.MstLog4TineLog_Facade.ClogMapper;
import de.desy.tine.server.logger.Clog;

/**
 * maps (adapts) __IRList<Clog> -> __IRList<LogMsg>
 * @author ws
 * @version 1.0.0
 */
class __ListMapper implements __IRList<LogMsg> {
	private final __IRList<Clog> srcLst;
	private final ClogMapper mapper;
//-----------------------------------------------------------------------------
	/**
	 * @param srcLst unmapped __IRList of Clogs
	 * @param mapper default Mapper (individual runs have nonsystem Clogs and the same mapper
	 */
	public __ListMapper(final __IRList<Clog> srcLst, final ClogMapper mapper) {
		this.srcLst = srcLst;
		this.mapper = mapper;
	}
//-----------------------------------------------------------------------------
	@Override public LogMsg get(final int index) {return map(getSrcLst().get(index));}
	@Override public int    size()               {return getSrcLst().size();}
	@Override public Iterator<LogMsg> iterator() {
		final Iterator<Clog> srcIt = getSrcLst().iterator();
		return new Iterator<LogMsg>(){
			@Override public boolean hasNext(){return srcIt.hasNext();}
			@Override public LogMsg  next() 	{return map(srcIt.next());}
			@Override public void    remove() {srcIt.remove();}
		};
	}
//-----------------------------------------------------------------------------
	private __IRList<Clog> 	getSrcLst() {return this.srcLst;}
	private ClogMapper 		getMapper(final Clog wrappedLogMsg) {
		final MstLog4TineLog_Facade facade = MstLog4TineLog_Facade.getInstance();
		if(facade.isSystemInfo(wrappedLogMsg))
			return facade.createClogMapper(wrappedLogMsg);
		else
			return this.mapper;
	}
	private LogMsg map(final Clog clog) {return getMapper(clog).map(clog);}
}
 