/**
 * May 15, 2009 - May 28, 2009	ws:	Creation from scratch
 * Sep 15, 2009 - Sep 15, 2009	ws:	use getMapAppName() for clarity
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;


import java.util.Date;
import java.util.UUID;

import de.desy.mst.libs.framework.mstapp.logging.EinfacherLogDeformatter;
import de.desy.mst.libs.framework.mstapp.logging.EinfacherLogFormatter;
import de.desy.mst.libs.framework.mstapp.logging.LogLvl;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.__MapContext.Context_RawLogMsgMsg_Pair;
import de.desy.tine.server.logger.ClsLog.ClogPriority;
import de.desy.tine.server.logger.ClsLog.ClogStatus;

/**
 * creates for an MstLog a new ClsLogInfo (does the mapping from MstLog 2 Tine)
 * @author ws
 * @version 1.0.0
 */
class ___MapEntireMsg {
	private static final ILogMsgFactory lmFactory = new LogMsgFactory();
	private static final __MapRunId 	mapRunId  = __MapRunId.get();
	private static final __MapAppName   mapAppName= __MapAppName.get();
//=============================================================================
	private final String pcName;
//-----------------------------------------------------------------------------
	public ___MapEntireMsg(final String pcName) {this.pcName = pcName;}
//-----------------------------------------------------------------------------
	public ClsLogInfo map(final LogMsg logMsg){
		final Context_RawLogMsgMsg_Pair pair = __MapContext.map(logMsg.message);
		final String context = pair.cLogContext;

		final String tag = logMsg.applikation;
		final String callerLogger = mapRunId.map(logMsg.runId);

		final __MapLogLvl mapLogLvl = __MapLogLvl.get(logMsg.level);
		final ClogPriority priority = mapLogLvl.getPriority();
		final ClogStatus   status   = mapLogLvl.getStatus();

		if(isSystemContext(context)) {
			final String text = pair.rawLogMsgMessage;
			return new __ClsLogInfoSystem(text			//text
										, tag			//tag
										, callerLogger	//caller bzw logger
										, priority		//priority
										, status);		//status
		}else{
			final String text = __MapText.create(logMsg.nr
											   , logMsg.date
											   , logMsg.kategorie
											   , pair).getText();

			return new __ClsLogInfoNonSystem(text			//text
										   , context		//context
										   , tag			//tag
										   , callerLogger	//caller bzw logger
										   , priority		//priority
										   , status);		//status
		}
	}
	public LogMsg map(final __ClsLogInfoNonSystem info) {
		final __MapText    mapText    = __MapText.create(info.text,   info.context);
		final __MapLogLvl  mapLogLvl  = __MapLogLvl.get (info.status, info.priority);
		final __MapRunId   mapRunId   = getMapRunId();
		final __MapAppName mapAppName = getMapAppName();

		final LogMsg logMsg = getILMFactory().create( mapText.getNr()
													, mapLogLvl.getLogLvl()
													, mapText.getDate()
													, mapAppName.map(info)
													, getPcName()
													, mapText.getKategorie()
													, mapText.getMessage()
													, null		//throwable
													, mapRunId.map(info.callerLogger));
		return logMsg;
	}
	public LogMsg map(final __ClsLogInfoSystem systemInfo) {

		final __MapTextSystem mapText  = __MapTextSystem.create(systemInfo.text);
		final __MapLogLvl   mapLogLvl  = __MapLogLvl.get(systemInfo.status, systemInfo.priority);
		final __MapRunId    mapRunId   = getMapRunId();
		final __MapAppName  mapAppName = getMapAppName();

		final LogMsg logMsg = getILMFactory().create( mapText.getLogMsgNr()
													, mapLogLvl.getLogLvl()
													, mapText.getLogMsgDate()
													, mapAppName.map(systemInfo)
													, mapText.pcName
													, Logger.SWFW_
													, mapText.getLogMsgMessage()
													, null		//throwable
													, mapRunId.map(systemInfo.callerLogger));
		return logMsg;
	}
//-----------------------------------------------------------------------------
	private final __MapRunId   getMapRunId  () {return ___MapEntireMsg.mapRunId;}
	private final __MapAppName getMapAppName() {return ___MapEntireMsg.mapAppName;}
	private final ILogMsgFactory 	getILMFactory() {return lmFactory;}
	private final String			getPcName() 	{return this.pcName;}

	private boolean isSystemContext(final String context) {
		return ClsLogInfo.isSystemContext(context);
	}
//=============================================================================
	private interface ILogMsgFactory{public LogMsg create(long nr, LogLvl level, Date date, String applikation, String pcName, Logger kategorie, String message, Throwable throwable, UUID runId);}
	private static class LogMsgFactory	extends 	EinfacherLogDeformatter
										implements	ILogMsgFactory{
		public LogMsgFactory() {super(new EinfacherLogFormatter());}
		@Override public LogMsg create(final long nr, final LogLvl level, final Date date, final String applikation, final String pcName, final Logger kategorie, final String message, final Throwable throwable, final UUID runId) {
			return createLogMsg(nr, level, date, applikation, pcName, kategorie,message, throwable, runId);
		}
	}
}
