/**
 *  Created on	May 26, 2006 - May 26, 2006
 */
package de.desy.mst.libs.framework.mstapp.mode;

import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * Kann erweitert werden aber bitte mit BetriebsVerz in Datenbank abgleichen
 * @author ws
 * @version 1.0.0
 */
public enum Betrieb {
	/**0 Unbekannter oder undefinierter Betrieb*/	UNKNOWN()	//Sicherheitshalber drin falls Framework nicht sauber Uebersetzen kann (etwas freundlicherer Ersatz fuer null)
	/**1 Elektronen Betrieb*/					  , E				
//	/**Protonen Betrieb*/						  , P
	;
	
//=============================================================================
	
	public final static Betrieb getByNr(final int betriebsNr){
		if(isInRange(betriebsNr)){
			return Betrieb.values()[betriebsNr];
		}else{
			return Betrieb.UNKNOWN;
		}
	}

	public final static boolean isInRange(final int betriebsNr) {
		return 0          <=  betriebsNr 
		    && betriebsNr <= (Betrieb.values().length - 1);
	}
	
//=============================================================================
	
	/**never null*/public final int    getBetriebsNr()  {return this.ordinal ();}
	public final String getBetriebsName(){return this.toString();}
	/**never null, no IllegalArgumentException*/
	public static Betrieb getByName(final String betriebsName) {
		try {
			return Betrieb.valueOf(betriebsName);
		} catch (IllegalArgumentException e) {
			Logger.SWFW.warn( "Unbekannter Betriebsname '" 
					        + betriebsName 
					        + "' setze zu Betrieb.UNKNOWN (" 
					        + Betrieb.class.getName()
					        + " getByName(final String betriebsName))"
					        );
			return Betrieb.UNKNOWN;
		}
	}
}
