/**
 *  Created on	Jun 21, 2006 - Jun 22, 2006
 */
package de.desy.mst.libs.framework.mstapp.mode;

import java.util.ArrayList;
import java.util.List;

import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.DeviceGruppe;

/**
 * Temporaere statische Hilfsklasse um die beste Setting zu erraten.
 * Idee, first call to DeviceTabelle auswerten.
 * MaschinenMgr koennen sich hier registrieren lassen.
 * <br>
 * FRAMEWORK INTERN ONLY
 * 
 * @author ws
 * @version 1.0.0
 */
public class MaschineGuessBestSetting {
	private static Maschine maschine = null;
	private static ArrayList<Maschine> erlaubteMaschinen = new ArrayList<Maschine>();
	private static List<IMaschineGuessBestSettingObserver> observers = new ArrayList<IMaschineGuessBestSettingObserver>();

//=============================================================================	
	
	public static void guessBestSettings(final DeviceGruppe deviceGruppe) {
		if(deviceGruppe == null){ 
			return;	//nothing to do
		}
		MaschineGuessBestSetting.maschine = deviceGruppe.getMaschine();
		MaschineGuessBestSetting.erlaubteMaschinen.clear();
		MaschineGuessBestSetting.erlaubteMaschinen.addAll(deviceGruppe.getMaschinenGleicherBasisXML());
		fireOnNewGuess();
	}
	public static void registerObserver(final IMaschineGuessBestSettingObserver observer) {
		if(observer != null && !observers.contains(observer)){
			observers.add(observer);
		}
	}
	public static void deregisterObserver(final IMaschineGuessBestSettingObserver observer) {
		observers.remove(observer);
	}

//=============================================================================	
	
	private static void fireOnNewGuess() {
		List<IMaschineGuessBestSettingObserver> copyOfObservers = new ArrayList<IMaschineGuessBestSettingObserver>(MaschineGuessBestSetting.observers); 
		for (IMaschineGuessBestSettingObserver observer : copyOfObservers) {
			observer.onNewGuess(MaschineGuessBestSetting.maschine, MaschineGuessBestSetting.erlaubteMaschinen);
		}
	}

}