/**
 * Created on Feb 21, 2005 - Apr 28, 2005
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 *	Mar 14, 2008 - Mar 14, 2008	ws: valueOf  == -> equals
 *	Jan 15, 2009 - Jan 15, 2009	ws:	added equals
 */
package de.desy.mst.libs.framework.mstapp.mode;

import java.awt.Color;
import javax.swing.JLabel;

/**
 * Enumerates alle ServerAnwahl'en
 * Value equality == Object equality
 * They can not be changed.
 * Auf die genauen Strings und Indizes ist zwischen LibReleases kein Verlass.
 * Die Objekte muessen fuer Vergleiche direkt benutzt werden.
 *
 *  Im Detail:
 *  <li><b>ServerAnwahl.DEFAULT</b> 			Defaultanwahl, kann auch Standalone sein</li>
 *  <li><b>ServerAnwahl.SIMULATIONSSERVER</b>  Simulationsserver</li>
 *
 * @author schuette
 *
 */
public class ServerAnwahl {
	public static final ServerAnwahl DEFAULT;
	public static final ServerAnwahl SIMULATIONSSERVER;
	public static final ServerAnwahl[] VALUES;

	static{
		//DEFAULT = new ServerAnwahl("Default", Color.BLACK, new Color(192,192,192) , 0);
		DEFAULT = new ServerAnwahl("Default", Color.BLACK, new JLabel().getBackground() , 0);
		SIMULATIONSSERVER  = new ServerAnwahl("Simulations Server", Color.WHITE, Color.RED , 1);
		VALUES = new ServerAnwahl[]{DEFAULT, SIMULATIONSSERVER};
	}

	public final String name;
	public final Color foreColor;
	public final Color backColor;
	public final int index;

	private ServerAnwahl(final String name, final Color foreColor, final Color backColor, final int index){
		this.name = name;
		this.foreColor = foreColor;
		this.backColor = backColor;
		this.index =index;
	}

	/** may return null*/
	public final static ServerAnwahl valueOf(final String name){
		for(int index = 0; index < VALUES.length; index++)
			if(name.equals(VALUES[index].name))
				return VALUES[index];
		return null;	//Maybe through an error instead?
	}
	/** may return null*/
	public static ServerAnwahl valueOf(final int index) {
		for(int i = 0; index < VALUES.length; i++){
			if(index == VALUES[i].index){return VALUES[i];}
		}
		return null;	//Maybe through an error instead?
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override public int hashCode() {return this.name.hashCode();}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override public boolean equals(final Object obj) {return this == obj;}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override public String toString() {return "Serveranwahl [" + this.name + "]";}

} 
