/**
 * ws:	Feb  9, 2007 - Feb 15, 2007 creation from Basisentwurf von Wst
 * ws:	May  9, 2007 - May 15, 2007	set*Size in XTor, beautify
 * ws:	Oct 30, 2008 - Oct 30, 2008	added getTitle()
 */
package de.desy.mst.libs.framework.mstapp.preferences.helper;
import javax.swing.JPanel;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstApp;
import de.desy.mst.libs.framework.mstapp.ParamDecoder;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.implementation.PrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.implementation.PrefManager;

/**
 * IPrefClient als JPanel mit Speichern von PrefStrings<br>
 * Manages den prefContainer;
 * @author ws
 * version 1.0.0
 */
public abstract class APrefClientPanel extends JPanel implements IPrefClient {
	private static final long serialVersionUID = 1L;
	private final IPrefContainer prefContainer;

//=============================================================================

	/**
	 * @param  prefContainer not null
	 * @throws NullPointerException, falls prefContainer == null
	 */
	public APrefClientPanel(final IPrefContainer prefContainer) {
		if(prefContainer   == null) {
			throw new NullPointerException("prefContainer");
		}
		this.prefContainer = prefContainer;

        final java.awt.Dimension panelSize = new java.awt.Dimension(200, 300);
		setMaximumSize  (panelSize);
        setMinimumSize  (panelSize);
        setPreferredSize(panelSize);
}
	/**Nur fuer den visual editor. Nicht benutzen.*/
	@Deprecated public APrefClientPanel() {
		this(new PrefContainer(new PrefManager(new MstApp(new Main("Dummy"), new ParamDecoder(new String[]{"faked"})), null)));
	}

//=============================================================================

	/**@return PrefContainer (never null)*/
	public final IPrefContainer getPrefContainer() {return this.prefContainer;}
	public       String getTitle() {return getPrefContainer().getTitle();}

	/**Bitte hier alle Ressourcen und Referenzen abgeben.*/ 
	public abstract void onDispose();

//=============================================================================

	void onDisposeForSystemUseOnly(){
		this.setVisible(false);
		try {
			this.onDispose();
		} catch (final Exception e) {
			final String msg = "Applikations Programm Fehler in onDispose()"
							 + " einer Einstellung.";
			Logger.SWFW.error(msg, e);
		}
	}
}
