/*
 * ws:	May 15, 2007 - May 15, 2007	changed:createPrefClientPanel() better Signature
 * 											onNewPrefString not final
 */
package de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SwingConstants;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.border.TitledBorder;

import de.desy.mst.libs.framework.mstapp.MstApp.TineAnbindung;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.PrefSpeicherMode;
import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;

@Deprecated public class PrefDebugLevelPanel extends JPanel implements IPrefClient{
	
	private static final long serialVersionUID = 4568663259196637290L;
	private JRadioButton jRadioButton1= null;
	private JRadioButton jRadioButton2 = null;
	private JRadioButton jRadioButton3 = null;
	private ButtonGroup buttonGroup=null;
	private JPanel jPnlDebugLevel = null;
	private int debugLevel=1;
	private int oldLevel=1;
	private boolean isChanged=false;
	private IPrefContainer prefContainer=null;
	private JCheckBox jCheckBox = null;
	private TineAnbindung tine=null;
	
	public PrefDebugLevelPanel(final TineAnbindung tine
							  ,final IPrefContainer prefContainer
							  ,final int debugLevel) {
		super();
		this.tine=tine;
		this.prefContainer=prefContainer;
		this.debugLevel=tine.getDebugLevel();
		initialize();
	}

	private	JRadioButton getJRadioButton1() {
		if (this.jRadioButton1 == null) {
			this.jRadioButton1 = new JRadioButton();
			this.jRadioButton1.setFont(GUIFactory.createButtonFont());
			this.jRadioButton1.setText("Debug Level 1");
			this.jRadioButton1.setSelected(true);
			this.jRadioButton1.addActionListener(new ActionListener() {
				@Override public void actionPerformed(final ActionEvent e) {
					final PrefDebugLevelPanel me=PrefDebugLevelPanel.this;
					me.oldLevel=me.debugLevel;
					me.debugLevel=1;
					Logger.SWFW.info("PrefDebugLevelPnl, actionPerformed()" 
							+",RadioButton1 debugLevel="+me.debugLevel
							+",  oldLevel="+me.oldLevel);		
					if (me.oldLevel !=me.debugLevel){
						PrefDebugLevelPanel.this.isChanged=true;
						PrefDebugLevelPanel.this.prefContainer.setChanged(PrefDebugLevelPanel.this.isChanged);
					}
				}
			});
		}
		return this.jRadioButton1;
	}
		
	private JRadioButton getJRadioButton2() {
		if (this.jRadioButton2 == null) {
			this.jRadioButton2 = new JRadioButton();
			this.jRadioButton2.setFont(GUIFactory.createButtonFont());
			this.jRadioButton2.setText("DebugLevel 2");
			this.jRadioButton2.addActionListener(new ActionListener() {
				@Override public void actionPerformed(final ActionEvent e) {
					final PrefDebugLevelPanel me=PrefDebugLevelPanel.this;
					me.oldLevel=me.debugLevel;
					me.debugLevel=2;
					Logger.SWFW.info("PrefDebugLevelPnl, actionPerformed()" 
							+",RadioButton2 debugLevel="+me.debugLevel
							+",  oldLevel="+PrefDebugLevelPanel.this.oldLevel);		
					if (me.oldLevel !=me.debugLevel){
						PrefDebugLevelPanel.this.isChanged=true;
						PrefDebugLevelPanel.this.prefContainer.setChanged(PrefDebugLevelPanel.this.isChanged);
					}
				}
			});
		}
		return this.jRadioButton2;
	}

	private JRadioButton getJRadioButton3() {
		if (this.jRadioButton3 == null) {
			this.jRadioButton3 = new JRadioButton();
			this.jRadioButton3.setFont(GUIFactory.createButtonFont());
			this.jRadioButton3.setText("Debug Level 3");
			this.jRadioButton3.addActionListener(new ActionListener() {
				@Override public void actionPerformed(final ActionEvent e) {
					final PrefDebugLevelPanel me=PrefDebugLevelPanel.this;
					me.oldLevel=me.debugLevel;
					me.debugLevel=3;
					Logger.SWFW.info("PrefDebugLevelPnl, actionPerformed()" 
						+",RadioButton3 debugLevel="+me.debugLevel
						+",  oldLevel="+me.oldLevel);		
				if (me.oldLevel !=me.debugLevel){
						PrefDebugLevelPanel.this.isChanged=true;
						PrefDebugLevelPanel.this.prefContainer.setChanged(PrefDebugLevelPanel.this.isChanged);
					}
				}
			});
		}
		return this.jRadioButton3;
	}

	private void initialize() {
		this.setSize(126, 200);
		this.add(getJPnlDebugLevel(), null);
		
		this.buttonGroup=new ButtonGroup();
		this.buttonGroup.add(getJRadioButton1());
		this.buttonGroup.add(getJRadioButton2());
		this.buttonGroup.add(getJRadioButton3());
		
		this.oldLevel=this.debugLevel;
		Logger.SWFW.info("PrefDebugLevelPnl() debugLevel="
				+this.debugLevel+",  oldLevel="+this.oldLevel);		
		setButtonGroupSelectedValue(this.debugLevel);
		
	}
 
	private JPanel getJPnlDebugLevel() {
		if (this.jPnlDebugLevel == null) {
			this.jPnlDebugLevel = new JPanel();
			this.jPnlDebugLevel.setLayout(new BoxLayout(this.jPnlDebugLevel
					, BoxLayout.Y_AXIS));
			this.jPnlDebugLevel.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Debug Level whlen"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION
								, new Font("Dialog",Font.BOLD,13), null));
			final Component vertGlue=Box.createVerticalGlue();
			final Component vertStrut=Box.createVerticalStrut(20);
			this.jPnlDebugLevel.add(vertStrut);
			this.jPnlDebugLevel.add(getJRadioButton1());
			this.jPnlDebugLevel.add(getJRadioButton2());
			this.jPnlDebugLevel.add(getJRadioButton3());
			this.jPnlDebugLevel.add(vertGlue);
			this.jPnlDebugLevel.add(getJCheckBox());
			this.jPnlDebugLevel.setPreferredSize(new Dimension(300,200));
		}
		return this.jPnlDebugLevel;
	}
		
	public void setButtonGroupSelectedValue(final int val){
		switch (val){
		case 1:
			getJRadioButton1().setSelected(true);
			break;
		case 2:
			getJRadioButton2().setSelected(true);
			break;
		case 3:
			getJRadioButton3().setSelected(true);
			break;
		}
	}

	@Override public String getSaveString() {
		Logger.SWFW.info("PrefDebugLevelPnl getSaveString ");		
		return "DebugLevel="+this.debugLevel;
	}

	@Override public void onReset() {
		this.debugLevel=this.oldLevel;
		Logger.SWFW.info("PrefDebugLevelPnl, onReset() debugLevel="
				+this.debugLevel+",  oldLevel="+this.oldLevel);		
		setButtonGroupSelectedValue(this.debugLevel);
	}

	@Override public void onSet() throws Exception {
		Logger.SWFW.info("PrefDebugLevelPnl onSet " +this.debugLevel);	
		this.tine.setDebugLevel(this.debugLevel);
	}

	
	private JCheckBox getJCheckBox() {
		if (this.jCheckBox == null) {
			this.jCheckBox = new JCheckBox();
			this.jCheckBox.setHorizontalAlignment(SwingConstants.LEFT);
			this.jCheckBox.setPreferredSize(new Dimension(200, 21));
			this.jCheckBox.setText("abspeichern?");
			this.jCheckBox.setMaximumSize(new Dimension(200, 24));
			this.jCheckBox.setMinimumSize(new Dimension(200, 24));
			this.jCheckBox.setVerticalAlignment(SwingConstants.BOTTOM);
			this.jCheckBox.setHorizontalAlignment(SwingConstants.RIGHT);
		}
		return this.jCheckBox;
	}

	@Override public PrefSpeicherMode getSpeicherMode() {
		return (this.jCheckBox.getModel().isSelected())? PrefSpeicherMode.APPLOCAL
												  : PrefSpeicherMode.MEMORYONLY;
	}

	
	
}


