/**
 * ws:	May 14, 2007 - May 15, 2007	changed:createPrefClientPanel() better Signature
 * 											onNewPrefString not final
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 */
package de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;
import javax.swing.border.BevelBorder;
import javax.swing.border.TitledBorder;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.PrefSpeicherMode;
import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;

import javax.swing.JCheckBox;
import javax.swing.SwingConstants;

public class PrefPositionConsolePnl extends JPanel implements IPrefClient {

	private static final long serialVersionUID = 1L;
	private static final Color selectedColor=new Color(0,200,200);
	private JPanel jPnlPosition = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	private JPanel jPanel21=null;
	private JPanel jPanel22=null;
	private JPanel jPanel221=null;
	private JPanel jPanel222=null;
	private JPanel jPanel3 = null;
	private JPanel jPanel31=null;
	private JPanel jPanel32=null;
	private JLabel jLabel = null;
	private final JLabel[] jLabels=new JLabel[9];  
	private static int screenIndex=-1;
	private int oldIndex=0;
	private boolean isChanged=false;
	private IPrefContainer prefContainer=null;
	private JCheckBox jCheckBox = null;
	private PrefPositionConsole prefPos=null;
		
	public PrefPositionConsolePnl(final PrefPositionConsole prefPos,final IPrefContainer prefContainer,final int index) {
		super();
		this.prefPos=prefPos;
		this.prefContainer=prefContainer;
		if (screenIndex==-1) screenIndex=index; // nur das 1. Mal
		initialize();
	}

	private void initialize() {
		this.setSize(300, 400);
		this.oldIndex=screenIndex;
		Logger.SWFW.info("PrefPositionPnl, initialize() screenIndex="
				+screenIndex+",  oldIndex="+this.oldIndex);		
		paintLabels(screenIndex);
		this.add(getJPnlPosition());
		this.add(getJCheckBox());
	}

	private JPanel getJPanel1() {
		if (this.jPanel1 == null) {
			this.jLabel = new JLabel();
			final String s="Klicken Sie auf die gewnschte Bildschirmposition:";
			this.jLabel.setText(s);
			this.jPanel1 = new JPanel();
			this.jPanel1.setLayout(new BoxLayout(getJPanel1(), BoxLayout.X_AXIS));
//			jPanel1.add(jLabel, null);
		}
		return this.jPanel1;
	}
	
	private JLabel getJLabels(final int ii){
		if (this.jLabels[ii]==null){
			this.jLabels[ii]=new JLabel();
			this.jLabels[ii].setOpaque(true);
			this.jLabels[ii].setBorder(BorderFactory
					   .createBevelBorder(BevelBorder.RAISED));
			this.jLabels[ii].setText("      ");
			Dimension d=null;
			switch(ii){
			case 0:
				d=new Dimension(100,80);
				break;
			case 1: case 2: case 3: case 4:
				d=new Dimension(50,40);
				break;
			case 5: case 6:
				d=new Dimension(100,40);
				break;
			case 7: case 8:
				d=new Dimension(50,80);
				break;
			}	
			this.jLabels[ii].setPreferredSize(d);
			this.jLabels[ii].setMaximumSize(d);
			this.jLabels[ii].setMinimumSize(d);

			this.jLabels[ii].addMouseListener(new MouseAdapter() {
				/* (non-Javadoc)
				 * @see java.awt.event.MouseAdapter#mouseClicked(java.awt.event.MouseEvent)
				 */
				@Override public void mouseClicked(final MouseEvent e) {
					final JLabel lbl=(JLabel)e.getSource();
					final JLabel[] jLbls=PrefPositionConsolePnl.this.jLabels;
					for (int i=0;i<jLbls.length;i++){
						jLbls[i].setBackground(Color.cyan);
					}	
					lbl.setBackground(selectedColor);
					for  (int i=0;i<jLbls.length;i++){
						if (jLbls[i].equals(lbl)){
							PrefPositionConsolePnl.screenIndex=i;
							break;
						}
					}
					if(PrefPositionConsolePnl.screenIndex != PrefPositionConsolePnl.this.oldIndex){
						PrefPositionConsolePnl.this.isChanged=true;
						paintLabels(screenIndex);
					}else{
						PrefPositionConsolePnl.this.isChanged=false;
					}
					PrefPositionConsolePnl.this.prefContainer.setChanged(PrefPositionConsolePnl.this.isChanged);
				}
			});
		} 
		return this.jLabels[ii];
	}
	
	private void paintLabels(final int screenIndex){
		Logger.SWFW.info("PrefPositionPnl, paintLabels() screenIndex="
				+screenIndex+",  oldIndex="+this.oldIndex);		
		for(int i=0;i<9;i++){
			if (i==screenIndex){
				getJLabels(i).setBackground(selectedColor);
			}else{	
				getJLabels(i).setBackground(Color.cyan);
			}	
			getJLabels(i).repaint();
		}
	}

	private JPanel getJPanel2(){
		if (this.jPanel2==null){
			this.jPanel2 = new JPanel();
			this.jPanel2.setLayout(new BoxLayout(getJPanel2(), BoxLayout.X_AXIS));
			this.jPanel2.add(getJPanel21(), null);
//			jPanel2.add(Box.createVerticalStrut(5), null);
			this.jPanel2.add(getJPanel22(), null);
		}
		return this.jPanel2;
	}
	
	private JPanel getJPanel21(){
		if (this.jPanel21==null){
			this.jPanel21 = new JPanel();
			this.jPanel21.setLayout(new BoxLayout(getJPanel21(), BoxLayout.X_AXIS));
			this.jPanel21.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Voller BildSchirm:"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION
								, GUIFactory.createButtonFont(), null));
			this.jPanel21.add(getJLabels(0), null);
		}
		return this.jPanel21;
	}
	private JPanel getJPanel22(){
		if (this.jPanel22==null){
			this.jPanel22 = new JPanel();
			this.jPanel22.setLayout(new BoxLayout(getJPanel22(), BoxLayout.Y_AXIS));
			this.jPanel22.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Viertel Bildschirm:"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION
								, GUIFactory.createButtonFont(), null));
			this.jPanel22.add(getJPanel221(), null);
			this.jPanel22.add(getJPanel222(), null);
		}
		return this.jPanel22;
	}

	private JPanel getJPanel221(){
		if (this.jPanel221==null){
			this.jPanel221 = new JPanel();
			this.jPanel221.setLayout(new BoxLayout(getJPanel221(), BoxLayout.X_AXIS));
			this.jPanel221.add(getJLabels(1), null);
			this.jPanel221.add(getJLabels(2), null);
		}
		return this.jPanel221;
	}
	
	private JPanel getJPanel222(){
		if (this.jPanel222==null){
			this.jPanel222 = new JPanel();
			this.jPanel222.setLayout(new BoxLayout(getJPanel222(), BoxLayout.X_AXIS));
			this.jPanel222.add(getJLabels(3), null);
			this.jPanel222.add(getJLabels(4), null);
		}
		return this.jPanel222;
	}
	
	private JPanel getJPanel3(){
		if (this.jPanel3==null){
			this.jPanel3 = new JPanel();
			this.jPanel3.setLayout(new BoxLayout(getJPanel3(), BoxLayout.X_AXIS));
			this.jPanel3.add(getJPanel31(), null);
//			jPanel3.add(Box.createVerticalStrut(5), null);
			this.jPanel3.add(getJPanel32(), null);
		}
		return this.jPanel3;
	}
	
	private JPanel getJPanel31(){
		if (this.jPanel31==null){
			this.jPanel31 = new JPanel();
			this.jPanel31.setLayout(new BoxLayout(getJPanel31(), BoxLayout.Y_AXIS));
			this.jPanel31.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Halber BildSchirm:"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION
								, GUIFactory.createButtonFont(), null));
			this.jPanel31.add(getJLabels(5), null);
			this.jPanel31.add(getJLabels(6), null);
		}
		return this.jPanel31;
	}
	
	private JPanel getJPanel32(){
		if (this.jPanel32==null){
			this.jPanel32 = new JPanel();
			this.jPanel32.setLayout(new BoxLayout(getJPanel32(), BoxLayout.X_AXIS));
			this.jPanel32.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Halber Bildschirm:"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION
								, GUIFactory.createButtonFont(), null));
			this.jPanel32.add(getJLabels(7), null);
			this.jPanel32.add(getJLabels(8), null);
		}
		return this.jPanel32;
	}

	
	private JPanel getJPnlPosition() {
		if (this.jPnlPosition == null) {
			this.jPnlPosition = new JPanel();
			this.jPnlPosition.setLayout(new BoxLayout(this.jPnlPosition
														, BoxLayout.Y_AXIS));
			this.jPnlPosition.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Klicken Sie auf die gewnschte Bildschirmposition:"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION, null, null));
			this.jPnlPosition.setAlignmentX(0.0F);
			this.jPnlPosition.setPreferredSize(new Dimension(300,240));
			final Component vertStrut=Box.createVerticalStrut(15);
			vertStrut.setPreferredSize(new Dimension(0, 80));
			this.jPnlPosition.add(getJPanel1(), null);
			this.jPnlPosition.add(getJPanel2(), null);
			this.jPnlPosition.add(getJPanel3(), null);
		}
		return this.jPnlPosition;
	}
	
	@Override public String getSaveString(){
		return "PrefPosition="+screenIndex;
	}

	@Override public void onReset() {
		Logger.SWFW.info("PrefPositionPnl reSet() ");		
		Logger.SWFW.info("PrefPositionPnl, reSet() screenIndex="
				+screenIndex+",  oldIndex="+this.oldIndex);		
		screenIndex=this.oldIndex;
		this.prefPos.setPositionOnScreen(screenIndex);
		paintLabels(screenIndex);
		
	}

	@Override public void onSet() throws Exception {
		Logger.SWFW.info("PrefPositionPnl set() "+screenIndex);		
		this.prefPos.setPositionOnScreen(screenIndex);
		paintLabels(screenIndex);
		
	}
		
	private JCheckBox getJCheckBox() {
		if (this.jCheckBox == null) {
			this.jCheckBox = new JCheckBox();
			this.jCheckBox.setHorizontalAlignment(SwingConstants.LEFT);
			this.jCheckBox.setPreferredSize(new Dimension(200, 21));
			this.jCheckBox.setText("Einstellung abspeichern");
			this.jCheckBox.setMaximumSize(new Dimension(200, 24));
			this.jCheckBox.setMinimumSize(new Dimension(200, 24));
			this.jCheckBox.setVerticalAlignment(SwingConstants.BOTTOM);
		}
		return this.jCheckBox;
	}
	

	public void setLabels(final int index) {
		Logger.SWFW.info("PrefPositionPnl setSaveString() "+index);		
		for (int i=0;i<this.jLabels.length;i++){
			this.jLabels[i].setBackground(Color.cyan);
		}	
		this.jLabels[index].setBackground(selectedColor);
		screenIndex=index;
		this.oldIndex=index;
		paintLabels(screenIndex);
	}

	@Override public PrefSpeicherMode getSpeicherMode() {
		return (this.jCheckBox.getModel().isSelected())? PrefSpeicherMode.APPLOCAL 
												  : PrefSpeicherMode.MEMORYONLY;
	} 
}
