/*
 * Created on 	Mar 30, 2005 - Mai 20, 2005
 * 	Oct 25, 2005 - ...			ws:	new logging system
 * 	Nov 26, 2008 - Dec 10, 2008	ws: deprecate SecurityRole, use MstSecurity Impl (preloaded)
 */
package de.desy.mst.libs.framework.mstapp.security;

import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * Central class for Application security
 * @author schuette
 * @version 1.0.0
 */
@Deprecated public final class MstSecurityMgr {
	@Deprecated private static SecurityRole securityRole = SecurityRole.OPERATEUR;
	public static final String HOSTNAME;
	public static final String HOSTADDRESS;
	public static final String USER;

	//author KH
	static{
		final MstSecurity mstSecurity = MstSecurity.get();
		HOSTNAME = mstSecurity.getHostName();
		HOSTADDRESS = mstSecurity.getHostAddress();
		USER = mstSecurity.getUser();
	}

	/**
	 * Access to the EnvironmentVariables of the PC as shown via the Java Virtual Machine
	 * A useful list of keys can be found in:
	 * Peter van der Linden "Just Java2" Table 19-6 on page 494
	 */

	final static class EnvironmentVariables{
		public static final String getUser() {
			return loadStringByKey("user.name", "?UNKNOWN?");
		}
		/**
		 * equivalent to System.getProperty(key, defaultValue)
		 * but all Exception's go to logger and the default will be returned
		 */
		public static final String loadStringByKey(String key, String defaultValue) {
			try {
				return System.getProperty(key, defaultValue);
			} catch (Exception e) {
				Logger.SWFW.warn("can not load '" + key + "'", e);
				return defaultValue;
			}
		}
	}

//=============================================================================
	//pure static class, there is exactly one security mgr in the app
	private MstSecurityMgr(){;}
//=============================================================================

	@Deprecated public static final boolean isInRole(SecurityRole securityRole){
		return (securityRole == getSecurityRole() || securityRole == SecurityRole.DEVELOPER);
	}

	/**old and obsolete and always SecurityRole.OPERATEUR*/
	@Deprecated public static final SecurityRole getSecurityRole() {return securityRole;}
}
