package de.desy.mst.libs.framework.mstapp.server;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;

import javax.swing.Icon;
import javax.swing.ImageIcon;

public class ServerIcon implements Icon{
	private Image image = null;
	private final int width;
	private final int height;
	public ServerIcon(final Image image, final int width, final int height){
		this.image = image;
		this.width = width;
		this.height = height;
	}
	private Image getImageIcon(){
		ImageIcon imageIcon = null;
		try{
			imageIcon = new ImageIcon(this.image);
		}catch(final Exception e){
			imageIcon = new ImageIcon(getClass().getResource("/resources/desy_logo.gif"));
		}
		return imageIcon.getImage();
	}

	@Override public int getIconHeight() {
		return this.height;
	}

	@Override public int getIconWidth() {
		return this.width;
	}

	@Override public void paintIcon(final Component c, final Graphics g, final int x, final int y) {
		g.drawImage(getImageIcon(), x, y, getIconWidth(), getIconHeight(), new Color(238,238,238), c);			
	}

}
