/**
 *  Created on  Aug 25, 2006 - Aug 31, 2006	ws
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten;

import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.DeviceDetail;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.DeviceDetailKey;

/**
 * Convenience Klasse fuer Tabellen von DevicesDetail's.
 * @author ws
 * @version 1.0.0
 */
public class DeviceDetailTabelle <D extends DeviceDetail> 
extends Tabelle<DeviceDetailKey, D>  {
	public DeviceDetailTabelle(final String tabId  ){super(tabId);}
	/**genau ein Entry, d.h. eine Zeile, unterstuetzt Defaults*/
	public final D getDeviceDetail(final DeviceDetailKey key){
		if(this.containsKey(key)) return getEntry(key);

		final DeviceDetailKey defaultKey = DeviceDetailKey.createDefaultKey(key);
		if(this.containsKey(defaultKey)) return getEntry(defaultKey);

		final DeviceDetailKey superDefaultKey = DeviceDetailKey.createSuperDefaultKey(key);
		if(this.containsKey(superDefaultKey)) return getEntry(superDefaultKey);
		
		return null;
	} 
	
	public boolean inSeinenWertenGleich(final int devGrNo, final int devNo, final DeviceDetailTabelle<D> other) {
		if(other == null) return false;
		DeviceDetailTabelle<D>  thisSubTable =  this.extractSubTable(devGrNo, devNo);
		DeviceDetailTabelle<D> otherSubTable = other.extractSubTable(devGrNo, devNo);
		return thisSubTable.inSeinenWertenGleich(otherSubTable);
	}
	public DeviceDetailTabelle<D> extractSubTable(int devGrNo, int devNo) {
		final String tabIdSurrogat = this.getTabId() + "###Computed SubTable " + devGrNo + ", " + devNo + "###";
		DeviceDetailTabelle<D> subTable = new DeviceDetailTabelle<D>(tabIdSurrogat);
		for (D detail : this) {
			if((detail.getDevGrNr() == devGrNo) && (detail.getDevGrNr() == devGrNo)) privatAdd(subTable, detail);
		}
		return subTable;
	}
	/**in extra private sub um deprecation zu ueberwinden, hier legales unterfangen*/
	@SuppressWarnings("deprecation")
	private boolean privatAdd(DeviceDetailTabelle<D> subTable, D detail) {
		return subTable.add(detail);
	}
}
