/**
 *  Created on	May 31, 2006 - Jun 06, 2006
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.TabellenEntry;

/**
 * Convenience Tabelle mit Tabellen Metadate<br>
 * DB: TabellenToJavaVerz<br>
 * Entries vom Typ TabellenEntry
 * @author ws
 * @version 1.0.0
 */
public class TabInfoTabelle extends Tabelle<Integer, TabellenEntry>{
	public final static String TABID = "TabInfoTabelle";
//=============================================================================	
	public TabInfoTabelle(final String tabId  )	{super(tabId);}
	public TabInfoTabelle()						{this(TabInfoTabelle.TABID);}
//=============================================================================	
	public final TabellenEntry getTabellenEntry(final int tbId){
		return getEntry (Integer.valueOf(tbId));
	}
	public final TabellenEntry getTabellenEntry(final String name, final int versionId){
		String nameToUpperCase = name.toUpperCase();
		for (TabellenEntry entry : this) {
			if(   entry.versionId == versionId 
			   && entry.name.toUpperCase().equals(nameToUpperCase)
			   ){
				return entry;
			}
		}
		return null;
	}
//=============================================================================
	/**@throws IllegalArgumentException, falls null oder doppelte Keys tabId oder (name, versioId)*/
	@SuppressWarnings("deprecation")	//ausnahmsweise erlaubt, da overwrite noetig
	@Override public boolean add(TabellenEntry zeile) {
		checkDoublePairKey(zeile);
		return super.add(zeile);
	}
	private void checkDoublePairKey(TabellenEntry zeile) {
		if(this.getTabellenEntry(zeile.name, zeile.versionId) != null){
			String msg = "Eintrag mit (name, versionId) = ("
					   +  zeile.name 	  + ", "
					   +  zeile.versionId + ") existiert schon."
					   ;
			IllegalArgumentException e = new IllegalArgumentException(msg);
			Logger.SW.error(msg, e);
			throw e;
		}
	}
	
}
