/**
 *  Created on 	Sep 19, 2005 - Sep 20, 2005
 * 				Oct 25, 2005 - ...	new logging system
 * 				Feb 19, 2006 - ...	getDevice(null) ist ok
 * 	Aug  6, 2009 - Aug  6, 2009	ws:	Eclipse asked for removing unnessary casts, so I did
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.devices;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.tabellendaten.AlleTabellen;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.DeviceGruppe;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.SedacDevice;

/**
 * @author ws
 * @version 1.0.0
 */
public class PeMag extends SedacDevice{
//DEVTYPE	BETRIEB	MUTTER	PSNR	NOMSTROM	MINBIT	MAXBIT	MINAMP	MAXAMP	APROBIT	OPTKON	SI_FACT	RESIST	KREISNR	PSNAME	STANDORT	IMS_LIMIT	IMS_L_DYN	POLWENDER	EXT_REGEL	REG_SOL	REG_IMS	REG_IST	REG_BST	TYN_SOLL	DVM_CNT	DVM_WAIT
//PSC2		e_pr	0		1100	3600	910	65535	50	3599.9451	0.0549	0.012343	1	0.87	28001	H2-4.1	Petra-NO	5	20	ja	nein	10	16	15	18	16	64	0.1	
	public enum DevType{PSC2, DIO,Unknown;
						public static DevType byString(final String betrieb) {
							try{return DevType.valueOf(betrieb);}
							catch(final Exception e){/*NOP*/;}
							return DevType.Unknown;
						}};
	public enum Betrieb{e_pr, pr, Unknown;
						public static Betrieb byString(final String betrieb) {
							try{return Betrieb.valueOf(betrieb);}
							catch(final Exception e){/*NOP*/;}
							return Betrieb.Unknown;
						}};
//-----------------------------------------------------------------------------	
	public final DevType devType;
	public final Betrieb betrieb;
	public final Integer devNoMutter;	//can be null (in Tabelle < 0)
	public final int 	 nomStrom;
	public final int 	 minBit;
	public final int 	 maxBit;
	public final double	 minAmp;
	public final double	 maxAmp;
	public final double	 aProBit;
	public final double	 optKon;
	public final double	 si_Fact;
	public final double	 resist;
	public final int 	 kreisNr;
	public final String	 psName;
	public final String  standort;	//evtl. spaeter Klasse via Tabelle
	
//=============================================================================	
	
	public PeMag(final int devGrNr, final int devNo, final String devName, final int sedLn, final int sedCr, final int sedSu
			   , final String devType, final String betrieb, final int devNoMutter
			   , final int nomStrom, final int minBit, final int maxBit, final double optKon
			   , final double si_Fact, final double resist, final int kreisNr
			   , final String psName, final String standort) {
		super(devGrNr, devNo, devName, sedLn, sedCr, sedSu);
		this.devType 	= DevType.byString(devType);
		this.betrieb	= Betrieb.byString(betrieb);
		this.devNoMutter= (devNoMutter <= 0) ? null : Integer.valueOf(devNoMutter);
		this.nomStrom 	= nomStrom;
		this.minBit 	= minBit;
		this.maxBit 	= maxBit;
		this.minAmp		= calcAmp (nomStrom, minBit);
		this.maxAmp		= calcAmp (nomStrom, maxBit);
		this.aProBit	= calcAProBit(nomStrom);
		this.optKon 	= optKon;
		this.si_Fact 	= si_Fact;
		this.resist 	= resist;
		this.kreisNr 	= kreisNr;
		this.psName 	= psName;
		this.standort 	= standort;
	}
	public PeMag(final int devGrNr, final int devNo, final String devName, final int sedLn, final int sedCr, final int sedSu
			   , final String devType, final String betrieb, final int devNoMutter
			   , final int nomStrom, final int minBit, final int maxBit, final double optKon
			   , final double si_Fact, final double resist, final int kreisNr
			   , final String psName, final String standort
	           , final Object ... unsupportedExtraParams) {
		this(      devGrNr,  devNo,   devName,   sedLn,   sedCr,   sedSu
			   ,   devType,  betrieb, devNoMutter
			   ,   nomStrom, minBit,  maxBit,    optKon
			   ,   si_Fact,  resist,  kreisNr
			   ,   psName,   standort);
		handleUnsupportedExtraParams(this, unsupportedExtraParams);
	}

//=============================================================================	
	
	public final static double ANZAHL_BITS = 65535.;	// == Hex FFFF
	
	public final static double calcAmp(final int nomStrom, final int bit) {;
		return ((double)nomStrom * (double)bit) / ANZAHL_BITS;
	}
	public final static double calcAProBit(final int nomStrom) {;
		return nomStrom / ANZAHL_BITS;
	}
	
//=============================================================================	
	public double getAProBit() 		{return this.aProBit;}
	public Betrieb getBetrieb() 	{return this.betrieb;}
	public Integer getDevNoMutter()	{return this.devNoMutter;}
	public PeMag   getMutter() 		{return getDevice(getDevNoMutter());}
	public PeMag   getDevice(final Integer devNo) {
		if(devNo == null)	{return null;}//z.B. bei getMutter() und diese existiert nicht
		PeMag peMag = null;
		try {peMag = (PeMag) AlleTabellen.getDeviceTabelle(DeviceGruppe.PeMag).getDevice(devNo.intValue());} 
		catch (final Exception e) {Logger.SWFW.error("Tried to retrieve a non existent PeMag " + devNo);}
		return peMag;
	}
	public DevType getDevType() 	{return this.devType;}
	public int     getKreisNr() 	{return this.kreisNr;}
	public double  getMaxAmp() 		{return this.maxAmp;}
	public int 	   getMaxBit() 		{return this.maxBit;}
	public double  getMinAmp() 		{return this.minAmp;}
	public int     getMinBit() 		{return this.minBit;}
	public int     getNomStrom() 	{return this.nomStrom;}
	public double  getOptKon() 		{return this.optKon;}
	public String  getPsName() 		{return this.psName;}
	public double  getResist() 		{return this.resist;}
	public double  getSi_Fact() 	{return this.si_Fact;}
	public String  getStandort() 	{return this.standort;}
	
	@Override public boolean inSeinenWertenGleich(final AEntry<Integer> otherEntry) {
		if(!(otherEntry instanceof PeMag)) {return false;}
		final PeMag other = (PeMag) otherEntry;
		return super.inSeinenWertenGleich(otherEntry)
			&& this.devType.equals(other.devType) 
			&& this.betrieb.equals(other.betrieb) 
			&& ((this.devNoMutter == other.devNoMutter))  
			&& this.nomStrom == other.nomStrom 
			&& this.minBit 	== other.minBit 
			&& this.maxBit 	== other.maxBit 
			&& this.optKon 	== other.optKon 
			&& this.si_Fact 	== other.si_Fact 
			&& this.resist 	== other.resist 
			&& this.kreisNr 	== other.kreisNr 
			&& this.psName.equals(other.psName) 
			&& this.standort.equals(other.standort) 
			;
	}
}
 