/**
 *  Created on  Aug 24, 2006  - Aug 31, 2006	ws
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

/**
 * Basis Klasse fuer Device Details (immer nur eine DevGruppenNummer Pro Tabelle)<br>
 * Erste  Schluesselspalte devNo<2>
 * Zweite Schluesselspalte E user spezifisch
 * @author ws
 *
 */
public abstract class DeviceDetail extends AEntry<DeviceDetailKey>{ 
	final DeviceDetailKey key;
//=============================================================================
	public DeviceDetail(final DeviceDetailKey key) {
		super();
		this.key = key;
	}
	public DeviceDetail(final int devGrNr, final int devNo, final int gruppe) {
		this(new DeviceDetailKey(devGrNr, devNo, gruppe));
	} 
	//=============================================================================
	@Override public DeviceDetailKey getKey()	{return this.key;}
	public final int getDevGrNr()	{return getKey().getDevGrNr();}
	public final int getDevNo()		{return getKey().getDevNo();}
	public final int getUserKey()	{return getKey().getUserKey();}
	@Override public boolean inSeinenWertenGleich(final AEntry<DeviceDetailKey> otherEntry) {
		if(otherEntry instanceof DeviceDetail){
			final DeviceDetail other = (DeviceDetail) otherEntry;
			return this.key.equals(other.key);
		}
		return false;	
	}
}
