/**
 *  Created on  Aug 29, 2006 - Aug 29, 2006	ws
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 *	Feb  3, 2009 - Feb  3, 2009 ws: fix equals for non instances of devicekey
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

import de.desy.mst.libs.framework.mstapp.tabellendaten.CompositeKey;

/**
 * Zusammengesetzter Schlssel fuer eine Device-Detail-Tabelle<br>
 * userKey (Typ Integer) ist der user spezifische Schluessel (die ersten beiden Schluessel
 * sind devGrNr und devNo)<br>
 * Immutable Class, lexikalisch sortiert mit Value orientierter Semantik
 * @author ws
 *
 */
public class DeviceKey implements Comparable<DeviceKey>{
	private final CompositeKey key; 
//=============================================================================
	public DeviceKey(final int devGrNr, final int devNo) {
		this.key = new CompositeKey(Integer.valueOf(devGrNr)	//0
								  , Integer.valueOf(devNo));	//1
	}
//=============================================================================
	public final int getDevGrNr(){return ((Integer) this.key.getKey(0)).intValue();}
	public final int getDevNo  (){return ((Integer) this.key.getKey(1)).intValue();}
//-----------------------------------------------------------------------------
	/** @see de.desy.mst.libs.framework.mstapp.tabellendaten.CompositeKey#compareTo(java.lang.Object)*/
	@Override public int compareTo(final DeviceKey other)	{return this.key.compareTo((other).key);}
	/** @see de.desy.mst.libs.framework.mstapp.tabellendaten.CompositeKey#equals(java.lang.Object)*/
	@Override public boolean equals(final Object other) {
		return other instanceof DeviceKey
			&& this.key.equals(((DeviceKey)other).key);
	}
	/** @see de.desy.mst.libs.framework.mstapp.tabellendaten.CompositeKey#hashCode()*/
	@Override public int hashCode()				{return this.key.hashCode();}
	/** @see de.desy.mst.libs.framework.mstapp.tabellendaten.CompositeKey#toString()*/
	@Override public String toString()			{return this.key.toString();}
}
