/**
 * 	Mar 30, 2015 - May  4, 2015	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

/**
 * Move OPModeACLEntry creation from OPModeACLEntry itself (via SQL Server)
 * to OPModeACLEntryFactory and subclasses to mitigate migration from 
 * SQL Server way to AnLas Tine server.
 * <p> The following explicit ways to create an OPModeACLEntry exist:
 * <li> The classical way via: 			_OPModeACLEntryFactory_SQLSrv
 * <li> The new Tine server way via:	OPModeACLEntryFactory_Tine
 * <li>	Via cashing on local file system: ########
 * <li> Via default instance:			 _OPModeACLEntryFactory_NullObject
 * <p> MstSecurity etc. should use the std way: 
 * <li>########
 * @author ws
 */
public abstract class OPModeACLEntryFactory {
	/**@return null or the corresponding OPModeACLEntry*/
	abstract public OPModeACLEntry getOPModeACLEntry(final String pcUser
			                                       , final String pcName
			                                       , final String appName);
	/**for testing only*/ @Deprecated abstract public boolean usesOldSQLWay();
	//---------------------------------------------------------------------------------------------
	OPModeACLEntry getNullOPModeACLEntry(final String pcUser
			                           , final String pcName
			                           , final String appName) {
		return getNullFactory().getOPModeACLEntry(pcUser, pcName, appName);
	}
	//=============================================================================================
	private OPModeACLEntryFactory getNullFactory() {
		return _OPModeACLEntryFactory_NullObject._INSTANCE;
	}
	/**for testing only*/ @Deprecated  protected OPModeACLEntryFactory __getSQLFactory() {
		return _OPModeACLEntryFactory_SQLSrv._INSTANCE;
	}
}
