package de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.listeners;

import javax.swing.*;

import de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.managers.ApplicationResizeManager;

/**
 * Listener resizing the JFrame
 * 
 * @author R.Bacher
 * @version 3.0.0
 *
 */	
public class ApplicationResizeListener {
	
	private JFrame myFrame = null;
	private ApplicationResizeManager myApplicationResizeManager = null;
	
	/**
	 * 
	 * Constructor
	 * 
	 * @param frame JFrame to be resized
	 * @param applicationResizeManager applicationResizeManager application resize manager attached to frame
	 * 
	 */	
	public ApplicationResizeListener(final JFrame frame, final ApplicationResizeManager applicationResizeManager) {
		this.myFrame = frame;
		this.myApplicationResizeManager = applicationResizeManager;
		initialize(); 
	}
	
	/**
	 * 
	 * Initializes the application resize manager
	 *
	 */
	private void initialize() {
	
		this.myFrame.addComponentListener(new java.awt.event.ComponentAdapter() {
			
	    	/**
	    	 * Recieves the component listener event "componentResized" and calls the corresponding method to resize the application.
	    	 * 
	    	 * @param listenerEvent Listener event
	    	 */	
			@Override public void componentResized(final java.awt.event.ComponentEvent listenerEvent) {
				ApplicationResizeListener.this.myApplicationResizeManager.resizeApplication();
			}
		});	
	
	}

}
