/**
 *  Created on  Aug 14, 2006 - Aug 17, 2006 ws fuer das JList Daten Modell um Logging Eintraege abzuspeichern.
 */
package de.desy.mst.libs.framework.mstapp.util.datastructures;

import java.util.Arrays;
import java.util.List;

/**
 * Speichert die letzten n Objekte vom Typ E.<br>
 * Implementation Cirkular abgelegte Daten im Array.<br>
 * Keine Daten werden entnommen, Groesse kann nicht geaendert werden<br>
 * @author ws
 *
 */
public class LastNObjects<E>{
	private Object[] daten;
	int nextIndex = 0;
	boolean filled = false;
	
//=============================================================================	
	
	public LastNObjects(final int capacity) {
		super();
		this.daten = new Object[capacity];
	}
	/**Copy-XTor <br>referenzVersion sollte nicht von einem anderen Thread geaendert werden!*/
	public LastNObjects(final int capacity, final LastNObjects<E> referenzVersion) {
		this(capacity);
		addElemente(referenzVersion);
	}

//=============================================================================	

	/**0 <= getCapacity()*/
	public int getCapacity()	{return this.daten.length;}
	/**0 <= getSize() <= getCapacity()*/
	public int getSize() 		{return this.filled ? getCapacity(): this.nextIndex;}
	@SuppressWarnings("unchecked")
	public E getElementAt(final int index) {
		int internalIndex = index;
		if(this.filled){
			//(index = 0) -> nextIndex
			internalIndex = (index + this.nextIndex) % getCapacity();
		}
		return (E)this.daten[internalIndex];
	}
	/**never null*/ @SuppressWarnings("unchecked")
	public List<E> getEntries() {
		final LastNObjects<E> copy = new LastNObjects<E>(this.getSize(), this);
		return (List<E>) Arrays.asList(copy.daten); 
	}
	/**true if size changed due to addElement, else false*/
	public boolean addElement(final E element){
		this.daten[this.nextIndex] = element;
		this.nextIndex = (this.nextIndex + 1) % getCapacity();
		if(!this.filled){ this.filled = (this.nextIndex == 0);}
		return !this.filled; 
	}

//=============================================================================	

	/**Hilfsfunktion fuer XTor*/
	private void addElemente(final LastNObjects<E> referenzVersion) {
		final int size = referenzVersion.getSize();
		for (int i = 0; i < size; i++) {
			final E element = referenzVersion.getElementAt(i);
			this.addElement(element);
		}
	}
}
