/**
 * Feb 23, 2009 - Feb 23, 2009	ws:	Creation from DialogShowingURI
 * Mar  5, 2010 - Mar  8, 2010	ws:	ein wenig an aboutBox Probleme anpassen
 * 									insbesondere: added getUserPanel()
 * Apr 28, 2010 - Apr 28, 2010	ws:	allow modal = FALSE for crashframe
 */
package de.desy.mst.libs.framework.mstapp.util.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

import de.desy.mst.libs.framework.mstapp.Screen;
import de.desy.mst.libs.framework.mstapp.hilfe.HelpMgr;
import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * HTML wird dargestellt. Schliessen mit Escape Key oder OK Button.
 * @author ws
 * @version 1.0.0
 */
public class DialogShowingHTML extends JDialogWithCloseOnEscape{
		private static final long serialVersionUID = 1L;
		//---------------------------------------------------------------------
		public static DialogShowingHTML createDialogShowingURI(final Component cmp, final String title, final String sUri){
			return createDialog(cmp, title, createEditorPaneFromSURI(sUri));
		}
		public static DialogShowingHTML createDialogShowingHTML(final Component cmp, final String title, final String sHTML){
			return createDialog(cmp, title, createEditorPaneFromSHTML(sHTML));
		}
		//---------------------------------------------------------------------
		private static DialogShowingHTML createDialog(final Component cmp, final String title, final JEditorPane editorPane) {
			final DialogShowingHTML dialog = new DialogShowingHTML(title, editorPane);
			dialog.setLocationRelativeTo(cmp);
			return dialog;
		}
		protected static JEditorPane createEditorPaneFromSURI(final String sUri) {
			try {
				final JEditorPane editorPane = new JEditorPane(sUri);
				editorPane.setEditable(false);
				editorPane.addHyperlinkListener(new HyperlinkListener(){
					@Override public void hyperlinkUpdate(final HyperlinkEvent evt) {
						if(evt.getEventType() != HyperlinkEvent.EventType.ACTIVATED)
							return;
						final String sUri = evt.getDescription();
						HelpMgr.show(sUri);	//extern anzeigen
					}
				});
				Logger.SWFW.info("ffne Link: '" + sUri + "'.");
				editorPane.setToolTipText("Link: " + sUri);
				return editorPane;
			} catch (final IOException e) {
				final String msg = "Kann nicht erzeugen: '" + sUri + "'";
				Logger.SWFW.warn(msg);
				return createEditorPaneFromSHTML(msg);
			}
		}
		private static JEditorPane createEditorPaneFromSHTML(final String sHTML) {
			final JEditorPane editorPane = new JEditorPane("text/html", sHTML);
			editorPane.setEditable(false);
			editorPane.addHyperlinkListener(new HyperlinkListener(){
				@Override public void hyperlinkUpdate(final HyperlinkEvent evt) {
					if(evt.getEventType() != HyperlinkEvent.EventType.ACTIVATED)
						return;
					final String sUri = evt.getDescription();
					HelpMgr.show(sUri);	//extern anzeigen
				}
			});
			return editorPane;
		}
//=============================================================================
//-----------------------------------------------------------------------------
		/**etwas unsauberer kludge um _AboutDialog reinzuquetschen, Idee HTML in userpanel eingebaut*/
		protected DialogShowingHTML(final String title, final Component centralCmp, final boolean modal){
			super((JFrame)null, title, modal);	//owner, title, modal

			this.setTitle(title);
			Screen.QUARTER.BOTTOM_LEFT.setBoundsOnComponent(this);
			Screen.center(this);

			final Container pane = getRootPane();
			pane.setLayout(new BorderLayout());
			pane.add(centralCmp, 		  BorderLayout.CENTER);
			pane.add(createButtonPanel(), BorderLayout.SOUTH);
		}
		protected DialogShowingHTML(final String title, final Component centralCmp){
			this(title, centralCmp, false);
		}
		private DialogShowingHTML(final String title, final JEditorPane editorPane) {
			super((JFrame)null, title, true);	//owner, title, modal

			this.setTitle(title);
			Screen.QUARTER.BOTTOM_LEFT.setBoundsOnComponent(this);
			Screen.center(this);

			final Container pane = getRootPane();
			pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
			pane.add(createEditorPanel(editorPane));
			pane.add(createButtonPanel());
		}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
		private JPanel createEditorPanel(final JEditorPane editorPane) {
			final JPanel panel = new JPanel(new BorderLayout());

			final JScrollPane scrollPane = new JScrollPane(editorPane, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			panel.add(scrollPane, BorderLayout.CENTER);
			return panel;
		}
		private Component createButtonPanel() {
			final JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
			panel.setAlignmentX(Component.RIGHT_ALIGNMENT);

				final JButton button = new JButton("Schliessen (Zurck)");
				button.setAlignmentX(Component.RIGHT_ALIGNMENT);
				button.addActionListener(new ActionListener(){
					/* (non-Javadoc)
					 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
					 */
					@Override public void actionPerformed(final ActionEvent e) {
						DialogShowingHTML.this.dispose();
					}
				});
			panel.add(button);
			return panel;
		}
	}
