package de.desy.mst.libs.framework.mstapp.util.machinestates;

/**
 * Defines the beam for states
 * 
 * @author R.Bacher
 *
 */

public enum EBeamFor {
	
	KEIN_BEDARF (1, "Kein Bedarf", "No Beam Request"),
	PETRA (2, "PETRA", "PETRA"),
	DORIS (3, "DORIS", "DORIS"),
	TESTSTRAHL (4, "Teststrahl", "Testbeam"),
	KONTROLLRAUM (5, "Kontrollraum", "Control Room"),
	UNBESTIMMT (6, "Unbestimmt", "Undefined");
	
	private final int stateAsNumber;
	private final String stateAsText;
	private final String stateAsTextEngl;
	
	EBeamFor(final int stateAsNumber, final String stateAsText, final String stateAsTextEngl) {
        this.stateAsNumber = stateAsNumber;
        this.stateAsText = stateAsText;
        this.stateAsTextEngl = stateAsTextEngl;
    }
	
	public int stateAsNumber() {
		
		return this.stateAsNumber;
	} 
	
	public String stateAsText() {
		
		return this.stateAsText;
	}
	public String stateAsTextEngl() {
		
		return this.stateAsTextEngl;
	}
	
	public static void main(final String[] args) {
		for (final EBeamFor state : EBeamFor.values()) {
           System.out.println(state + ": " + state.stateAsNumber + ", " + state.stateAsText + ", " + state.stateAsTextEngl);
		}
    }
}
