package de.desy.mst.libs.framework.mstapp.util.machinestates;

/**
 * Defines the machine states
 * 
 * @author R.Bacher
 *
 */

public enum EMachineStatesD2 {
	
	DESY_BETRIEB_PETRA (110, "Betrieb->PETRA", "User Operations->PETRA"),
	DESY_BETRIEB_PETRA_IDLE (1100, "Betrieb->PETRA(ohne Strahlejektion)", "User Operations->PETRA(without beam ejection)"),
	DESY_BETRIEB_PETRA_BEAM (1101, "Betrieb->PETRA(mit Strahlejektion)", "User Operations->PETRA(with beam ejection)"),
	DESY_BETRIEB_DORIS (111, "Betrieb->DORIS", "User Operations->DORIS"),
	DESY_BETRIEB_TESTSTRAHL (112, "Betrieb->Teststrahl", "User Operations->Testbeam"),
	DESY_BETRIEB_KONTROLLRAUM (113, "Betrieb->Kontrollraum", "User Operations->Control Room"),
	DESY_VORBEREITEN_BETRIEB (200, "Vorbereiten(Betrieb)", "Preparing(User Operations)"),
	DESY_VORBEREITEN_BETRIEB_PETRA (210, "Vorbereiten(Betrieb->PETRA)", "Preparing(User Operations->PETRA)"),
	DESY_VORBEREITEN_BETRIEB_DORIS (211, "Vorbereiten(Betrieb->DORIS)", "Preparing(User Operations->DORIS)"),
	DESY_VORBEREITEN_BETRIEB_TESTSTRAHL (212, "Vorbereiten(Betrieb->Teststrahl)", "Preparing(User Operations->Testbeam)"),
	DESY_VORBEREITEN_BETRIEB_KONTROLLRAUM (213, "Vorbereiten(Betrieb->Kontrollraum)", "Preparing(User Operations->Control Room)"),
	DESY_BEREIT (300, "Bereit", "Idle"),
	DESY_BEREIT_BETRIEB (301, "Bereit(Betrieb)", "Idle(User Operations)"),
	DESY_BEREIT_SPARBETRIEB (302, "Bereit(Sparbetrieb)", "Idle(Power Saving Operations)"),
	DESY_BEREIT_AUS (303, "Bereit(Aus)", "Idle(Off)"),
	DESY_WARTUNG (401, "Wartung", "Maintenance"),
	DESY_FEHLER (402, "Fehler", "Problems"),
	DESY_KEINE_STRAHLFREIGABE (403, "Keine Strahlfreigabe", "Beam Permission Unavailable"),
	DESY_KEIN_STRAHL (404, "Kein Strahl", "No Beam"),
	DESY_STUDIEN (500, "Studien", "Studies"),
	DESY_UNBESTIMMT (600, "Unbestimmt", "Undefined");
	
	private final int stateAsNumber;
	private final String stateAsText;
	private final String stateAsTextEngl;
	
	EMachineStatesD2(final int stateAsNumber, final String stateAsText, final String stateAsTextEngl) {
        this.stateAsNumber = stateAsNumber;
        this.stateAsText = stateAsText;
        this.stateAsTextEngl = stateAsTextEngl;
    }
	
	public int stateAsNumber() {
		
		return this.stateAsNumber;
	}
	
	public String stateAsText() {
		
		return this.stateAsText;
	}
	public String stateAsTextEngl() {
		
		return this.stateAsTextEngl;
	} 
	
	public static void main(final String[] args) {
		for (final EMachineStatesD2 state : EMachineStatesD2.values()) {
           System.out.println(state + ": " + state.stateAsNumber + ", " + state.stateAsText+ ", " + state.stateAsTextEngl);
		}
    }
}
