package de.desy.mst.libs.framework.mstapp.util.machinestates;

/**
 * Defines the machine states
 * 
 * @author R.Bacher
 *
 */

public enum EMachineStatesP3 {
	
	PETRA_BETRIEB (100, "Betrieb", "User Operations"),
	PETRA_BETRIEB_EXPERIMENT (101, "Betrieb->Experiment", "User Operations->Experiments"),
	PETRA_BETRIEB_KONTROLLRAUM(102, "Betrieb->Kontrollraum", "User Operations->Control Room"),
	PETRA_VORBEREITEN_BETRIEB (200, "Vorbereiten", "Preparing"),
	PETRA_BEREIT (300, "Bereit", "Idle"),
	PETRA_WARTUNG (400, "Wartung", "Maintenance"),
	PETRA_NOBEAM (401, "Kein Strahl", "No Beam"),
	PETRA_FEHLER (402, "Fehler", "Problems"),
	PETRA_KEINE_STRAHLFREIGABE (403, "Keine Strahlfreigabe", "Beam Permission Unavailable"),
	PETRA_STUDIEN (500, "Studien", "Studies"),
	PETRA_UNBESTIMMT (600, "Unbestimmt", "Undefined");
	
	private final int stateAsNumber;
	private final String stateAsText;
	private final String stateAsTextEngl;
	
	EMachineStatesP3(final int stateAsNumber, final String stateAsText, final String stateAsTextEngl) {
        this.stateAsNumber = stateAsNumber;
        this.stateAsText = stateAsText;
        this.stateAsTextEngl = stateAsTextEngl;
    }
	
	public int stateAsNumber() {
		
		return this.stateAsNumber;
	}
	
	public String stateAsText() {
		
		return this.stateAsText;
	}
	public String stateAsTextEngl() {
		
		return this.stateAsTextEngl;
	}
	
	public static void main(final String[] args) {
		for (final EMachineStatesP3 state : EMachineStatesP3.values()) {
           System.out.println(state + ": " + state.stateAsNumber + ", " + state.stateAsText+ ", " + state.stateAsTextEngl);
		}
    }
} 
