/**
 * ws:	Mar 14, 2007 - Mar 14, 2007 creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.util.reflection;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Date;

import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * Try to retrieve some Information about Versions of Files.
 * <br> For the Moment only last compile time.
 * <br> rein statische Klasse
 * @author ws
 * version 1.0.0
 */
public final class VersionInfo {

	/**
	 * Implementation nach http://codeconsult.ch/bertrand/archives/000767.html
	 * @param  object dieser Klasse
	 * @return Date wann die Klasse zuletzt uebersetzt wurde oder null
	 */
	public static Date whenWasLastCompiled(final Object object){
    	try {
			final String name = object.getClass().getName().replace(".", "/") 
			                  +  ".class";
			final URL resource = ClassLoader.getSystemClassLoader().getResource(name);
			final URLConnection connection = resource.openConnection();
			final Date date = new Date(connection.getLastModified());
			return date;
		} catch (IOException e) {
			Logger.SWFW.warn("Can not get Infos for: '" + object + "'.", e);
		}
		return null;
	}
	
//=============================================================================
	
	private VersionInfo(){/*rein statische Klasse*/}
}
