/**
 *  Created on	Jan 27, 2006 - Jan 27, 2006
 */
package de.desy.mst.libs.framework.mstapp.util.xml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;;

/**
 * Zur Unterstuetzung der Selbstbeschreibung von (geschachtelten) Objekten.
 * Wichtige Implementations Hilfsklasse: AXmlBeschreibung
 * @author ws
 * @version 1.0.0
 */
public interface IXmlBeschreibung {
	/**
	 * @param  nTabs >= 0, Tabs als Zeilenpraefix, 
	 * damit geschachtelte Objekte gut aussehen
	 * @return Selbstbeschreibung des Objektes in wohlgeformter XML
	 */
	public String getXMLBeschreibung(final int nTabs);
	
	/**
	 * @param	document (may be null, soll intern nicht geaendert werden, dient lediglich zur Herstellung der Nodes)
	 * @return	liefert einen DOM Node als Selbstbeschreibung
	 */
	public Element getBeschreibungAsElement(final Document document);

}